/*
 * adcs.c
 *
 * Created: 19.02.2015 14:44:59
 *  Author: mariuwes
 */ 

// Overhead
#include "adcs.h"
#include "logging.h"

// Sensors
#include "sun_sensor.h"
#include "magnetometer.h"
#include "gyroscope.h"

// Estimator and Predictor
#include "predictor.h"
#include "estimator.h"

// Actuators and Controllers
#include "detumbling_controller.h"
#include "pointing_controller.h"
#include "coil_driver.h"


int adcs_initialize(void) {
		
	magnetometer_initialize();
	gyroscope_initialize();
	sun_sensor_initialize();
	coil_driver_initialize();
	detumbling_controller_intialize();
	pointing_controller_intialize();
	predictor_initialize();
		
	return 42;
}

int adcs_poll_sensor_data(int16_t sensor_data[34]) {
	
	gyroscope_poll(&sensor_data[0]);
	gyroscope_poll(&sensor_data[3]);
	magnetometer_poll(&sensor_data[6]);
	magnetometer_poll(&sensor_data[9]);
	magnetometer_poll(&sensor_data[12]);
	magnetometer_poll(&sensor_data[15]);
	sun_sensor_poll(&sensor_data[18]);
	
	return 42;
}


