/*
 * coil_driver.c
 *
 * Created: 28.02.2014 11:35:11
 *  Author: yvind Rein
 * Edited: 15.11.2014
 *	By: Marius Westgaard
 */ 
/*
#include "coil_driver.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include "../constants.h"

#define COIL_PER 22000 //11000
int coils_off;

int coil_driver_initialize(){
	PORTC_DIR |= 0x07; //  Set pin CXSLEEP, CYSLEEP and CZSLEEP to output.
	PORTD_DIR |= 0x0F; // Set pin CX_PHASE, CX_PWM, CY_PHASE and CY_PWM to output.
	PORTE_DIR |= 0x0C; // Set pin CZ_PHASE and CZ_PWM to output
	PORTE_DIR &= ~0x13; // Set pin CX_BR_FAULT, CY_BR_FAULT and CZ_BR_FAULT to input.
	set_coil(COIL_X, COIL_OFF);
	set_coil(COIL_Y, COIL_OFF);
	set_coil(COIL_Z, COIL_OFF);
	coils_off = 1;
	PORTC_OUTSET |= 0x07; // Set pin CXSLEEP, CYSLEEP and CZSLEEP to high. Disables sleep mode
	return 1;
}

void coil_output(int16_t output_vector[3]){ // Values from -2048 to 2047. 12 bit accuracy
	// Change it so that the axes are correct
	int16_t temp_coil = output_vector[0];
	output_vector[0] = output_vector[1];
	output_vector[1] = temp_coil;
	output_vector[0] *= -1;
	output_vector[1] *= -1;
	output_vector[2] *= -1;
	
	
	coils_off = 0;
	int16_t coil_x_output = output_vector[0];
	int16_t coil_y_output = output_vector[1];
	int16_t coil_z_output = output_vector[2];
	
	if (coil_x_output < 0){
		coil_x_output = -1*coil_x_output;
		set_coil(COIL_X, COIL_NEG);
	}else{
		set_coil(COIL_X, COIL_POS);
	}
	if (coil_y_output < 0){
		coil_y_output = -1*coil_y_output;
		set_coil(COIL_Y, COIL_NEG);
	}else{
		set_coil(COIL_Y, COIL_POS);
	}
	if (coil_z_output < 0){
		coil_z_output = -1*coil_z_output;
		set_coil(COIL_Z, COIL_NEG);
	}else{
		set_coil(COIL_Z, COIL_POS);
	}
	if (coil_x_output > COIL_MAX) {
		coil_x_output = COIL_MAX;
	}
	if (coil_y_output > COIL_MAX) {
		coil_y_output = COIL_MAX;
	}
	if (coil_z_output > COIL_MAX) {
		coil_z_output = COIL_MAX;
	} 
	TCC0.CTRLA = TC_CLKSEL_DIV256_gc;
	TCC0.PER = COIL_PER; // PER = 500, fCPU = 32M and DIV = 64 gives 1000hz sampling
	PMIC.CTRL = PMIC_LOLVLEN_bm;
	TCC0.INTFLAGS = 0b01110001;
	TCC0.CCA = (COIL_PER*(float)coil_x_output)/COIL_MAX;
	TCC0.CCB = (COIL_PER*(float)coil_y_output)/COIL_MAX;
	TCC0.CCC = (COIL_PER*(float)coil_z_output)/COIL_MAX;
	TCC0.CTRLFSET = TC_CMD_RESTART_gc; // Restart timer. 
	TCC0.INTCTRLB = 0b00010101; // Set interrupt level to low for CCA, CCB and CCC
	TCC0.INTCTRLA = TC_OVFINTLVL_LO_gc;
}

ISR(TCC0_CCA_vect){
	set_coil(COIL_X, COIL_OFF);
}

ISR(TCC0_CCB_vect){
	set_coil(COIL_Y, COIL_OFF);
}

ISR(TCC0_CCC_vect){
	set_coil(COIL_Z, COIL_OFF);
}

ISR(TCC0_OVF_vect){
	set_coil(COIL_X, COIL_OFF);
	set_coil(COIL_Y, COIL_OFF);
	set_coil(COIL_Z, COIL_OFF);
	TCC0.INTCTRLA = 0x00; // Turn off interrupts
	TCC0.INTCTRLB = 0x00;
	coils_off = 1;
}

int coils_are_off(){
	return coils_off;
}

void set_coil(int coil, int dir){
	
	if (coil == COIL_X){
		if (dir == COIL_OFF){
			PORTD_OUT &= ~CX_PWM;
		}
		else if (dir == COIL_POS){
			PORTD_OUT &= ~CX_PHASE; 
			PORTD_OUTSET |= CX_PWM;
		}
		else if (dir == COIL_NEG){
			PORTD_OUTSET |= CX_PHASE;
			PORTD_OUTSET |= CX_PWM;
		}
	}
	
	else if (coil == COIL_Y){
		if (dir == COIL_OFF){
			PORTD_OUT &= ~CY_PWM;
		}
		else if (dir == COIL_POS){
			PORTD_OUT &= ~CY_PHASE;
			PORTD_OUTSET |= CY_PWM;
		}
		else if (dir == COIL_NEG){
			PORTD_OUTSET |= CY_PHASE;
			PORTD_OUTSET |= CY_PWM;
		}
	}
	
	else if (coil == COIL_Z){
		if (dir == COIL_OFF){
			PORTE_OUT &= ~CZ_PWM;
		}
		else if (dir == COIL_POS){
			PORTE_OUT &= ~CZ_PHASE;
			PORTE_OUTSET |= CZ_PWM;
		}
		else if (dir == COIL_NEG){
			PORTE_OUTSET |= CZ_PHASE;
			PORTE_OUTSET |= CZ_PWM;
		}
	}
	return;	
}

*/

int coil_driver_initialize(){
	
	return 42;
}