/*
 * File: EKF.c
 *
 * Code generated for Simulink model 'EKF'.
 *
 * Model version                  : 1.121
 * Simulink Coder version         : 8.6 (R2014a) 27-Dec-2013
 * C/C++ source code generated on : Tue Dec 16 03:58:53 2014
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives:
 *    1. Execution efficiency
 *    2. Safety precaution
 *    3. RAM efficiency
 *    4. MISRA-C:2004 guidelines
 * Validation result: Passed (21), Warning (1), Error (0)
 */

#include "EKF.h"
#include "EKF_private.h"

/* Block signals and states (auto storage) */
DW_EKF_T EKF_DW;

/* External inputs (root inport signals with auto storage) */
ExtU_EKF_T EKF_U;

/* External outputs (root outports fed by signals with auto storage) */
ExtY_EKF_T EKF_Y;

/* Model step function */
void EKF_step(void)
{
   real32_T e1rs3;
   real32_T e1rs2;
   real32_T e1rs1;
   real32_T e1rm3;
   real32_T e1rm2;
   real32_T e1rm1;
   real32_T e3rs3;
   real32_T e3rs2;
   real32_T e3rs1;
   real32_T e3rm1;
   real32_T e3rm2;
   real32_T e3rm3;
   real32_T e2rs3;
   real32_T e2rs2;
   real32_T e2rs1;
   real32_T e2rm3;
   real32_T e2rm2;
   real32_T e2rm1;
   real32_T nurs3;
   real32_T nurs2;
   real32_T nurs1;
   real32_T nurm3;
   real32_T nurm2;
   real32_T nurm1;
   real32_T H[60];
   real32_T Rb_n[9];
   real32_T K[60];
   real32_T temp[100];
   real32_T v[10];
   real32_T d[36];
   real32_T b_v[6];
   int8_T I[16];
   int8_T b_I[36];
   int16_T j;
   static const int8_T b[100] = { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 1 };

   real32_T H_0[36];
   real32_T H_1[60];
   real32_T Rb_n_0[3];
   real32_T Rb_n_1[3];
   real32_T Rb_n_2[6];
   real32_T tmp[6];
   real32_T temp_0[100];
   real32_T temp_1[100];
   real32_T K_0[100];
   real32_T tmp_0[16];
   real32_T temp_2[10];
   int16_T i;
   int16_T i_0;

   /* MATLAB Function: '<S1>/EKF' incorporates:
    *  Inport: '<Root>/P_0'
    *  Inport: '<Root>/R'
    *  Inport: '<Root>/q_0'
    *  Inport: '<Root>/r_m'
    *  Inport: '<Root>/r_s'
    *  Inport: '<Root>/z_n'
    */
   /* GyroVect  W = [wx,wy,wz]   body frame */
   /* SunVect   s = [sx,sy,sz]   body frame */
   /* MagVect   m = [mx, my, mz] body frame */
   /* Measurment vector z = [s m]'  */
   /* h      Step time  */
   /* q_0    Init quaternion      */
   /* r_s reference SunVect */
   /* r_m reference MagVect */
   /* MATLAB Function 'EKF/EKF': '<S2>:1' */
   /* % Initialization  */
   /* '<S2>:1:20' if isempty (Xhat) */
   if (!EKF_DW.Xhat_not_empty) {
      /* '<S2>:1:21' b1 =single([0 0 0]); */
      /* '<S2>:1:22' b2 =single([0 0 0]); */
      /* '<S2>:1:23' Xhat = [ q_0' b1 b2]'; */
      EKF_DW.Xhat[0] = EKF_U.q_0[0];
      EKF_DW.Xhat[1] = EKF_U.q_0[1];
      EKF_DW.Xhat[2] = EKF_U.q_0[2];
      EKF_DW.Xhat[3] = EKF_U.q_0[3];
      EKF_DW.Xhat[4] = 0.0F;
      EKF_DW.Xhat[5] = 0.0F;
      EKF_DW.Xhat[6] = 0.0F;
      EKF_DW.Xhat[7] = 0.0F;
      EKF_DW.Xhat[8] = 0.0F;
      EKF_DW.Xhat[9] = 0.0F;
      EKF_DW.Xhat_not_empty = true;

      /* '<S2>:1:25' P = diag([P_0(1) P_0(1) P_0(1) P_0(1) P_0(2) P_0(2) P_0(2) P_0(2) P_0(2) P_0(2)]); */
      v[0] = EKF_U.P_0[0];
      v[1] = EKF_U.P_0[0];
      v[2] = EKF_U.P_0[0];
      v[3] = EKF_U.P_0[0];
      v[4] = EKF_U.P_0[1];
      v[5] = EKF_U.P_0[1];
      v[6] = EKF_U.P_0[1];
      v[7] = EKF_U.P_0[1];
      v[8] = EKF_U.P_0[1];
      v[9] = EKF_U.P_0[1];
      memset(&EKF_DW.P[0L], (int16_T)0.0F, 100U * (sizeof(real32_T)));
      for (j = 0; j < 10; j++) {
         EKF_DW.P[j + (10 * j)] = v[j];
      }
   }

   /* % Uppdating system matrices.       */
   /* 	Uppdating linearized H */
   /* '<S2>:1:33' e1rs3 = 2*Xhat(2)*(r_s(3)); */
   e1rs3 = (2.0F * EKF_DW.Xhat[1]) * EKF_U.r_s[2];

   /* '<S2>:1:34' e1rs2 = 2*Xhat(2)*(r_s(2)); */
   e1rs2 = (2.0F * EKF_DW.Xhat[1]) * EKF_U.r_s[1];

   /* '<S2>:1:35' e1rs1 = 2*Xhat(2)*(r_s(1)); */
   e1rs1 = (2.0F * EKF_DW.Xhat[1]) * EKF_U.r_s[0];

   /* '<S2>:1:37' e1rm3 = 2*Xhat(2)*(r_m(3)); */
   e1rm3 = (2.0F * EKF_DW.Xhat[1]) * EKF_U.r_m[2];

   /* '<S2>:1:38' e1rm2 = 2*Xhat(2)*(r_m(2)); */
   e1rm2 = (2.0F * EKF_DW.Xhat[1]) * EKF_U.r_m[1];

   /* '<S2>:1:39' e1rm1 = 2*Xhat(2)*(r_m(1)); */
   e1rm1 = (2.0F * EKF_DW.Xhat[1]) * EKF_U.r_m[0];

   /* '<S2>:1:41' e3rs3 = 2*(Xhat(4))*(r_s(3)); */
   e3rs3 = (2.0F * EKF_DW.Xhat[3]) * EKF_U.r_s[2];

   /* '<S2>:1:42' e3rs2 = 2*(Xhat(4))*(r_s(2)); */
   e3rs2 = (2.0F * EKF_DW.Xhat[3]) * EKF_U.r_s[1];

   /* '<S2>:1:43' e3rs1 = 2*(Xhat(4))*(r_s(1)); */
   e3rs1 = (2.0F * EKF_DW.Xhat[3]) * EKF_U.r_s[0];

   /* '<S2>:1:45' e3rm1 = 2*(Xhat(4))*(r_m(1)); */
   e3rm1 = (2.0F * EKF_DW.Xhat[3]) * EKF_U.r_m[0];

   /* '<S2>:1:46' e3rm2 = 2*(Xhat(4))*(r_m(2)); */
   e3rm2 = (2.0F * EKF_DW.Xhat[3]) * EKF_U.r_m[1];

   /* '<S2>:1:47' e3rm3 = 2*(Xhat(4))*(r_m(3)); */
   e3rm3 = (2.0F * EKF_DW.Xhat[3]) * EKF_U.r_m[2];

   /* '<S2>:1:50' e2rs3 = 2*(Xhat(3))*(r_s(3)); */
   e2rs3 = (2.0F * EKF_DW.Xhat[2]) * EKF_U.r_s[2];

   /* '<S2>:1:51' e2rs2 = 2*(Xhat(3))*(r_s(2)); */
   e2rs2 = (2.0F * EKF_DW.Xhat[2]) * EKF_U.r_s[1];

   /* '<S2>:1:52' e2rs1 = 2*(Xhat(3))*(r_s(1)); */
   e2rs1 = (2.0F * EKF_DW.Xhat[2]) * EKF_U.r_s[0];

   /* '<S2>:1:54' e2rm3 = 2*(Xhat(3))*(r_m(3)); */
   e2rm3 = (2.0F * EKF_DW.Xhat[2]) * EKF_U.r_m[2];

   /* '<S2>:1:55' e2rm2 = 2*(Xhat(3))*(r_m(2)); */
   e2rm2 = (2.0F * EKF_DW.Xhat[2]) * EKF_U.r_m[1];

   /* '<S2>:1:56' e2rm1 = 2*(Xhat(3))*(r_m(1)); */
   e2rm1 = (2.0F * EKF_DW.Xhat[2]) * EKF_U.r_m[0];

   /* '<S2>:1:58' nurs3 = 2*(Xhat(1))*(r_s(3)); */
   nurs3 = (2.0F * EKF_DW.Xhat[0]) * EKF_U.r_s[2];

   /* '<S2>:1:59' nurs2 = 2*(Xhat(1))*(r_s(2)); */
   nurs2 = (2.0F * EKF_DW.Xhat[0]) * EKF_U.r_s[1];

   /* '<S2>:1:60' nurs1 = 2*(Xhat(1))*(r_s(1)); */
   nurs1 = (2.0F * EKF_DW.Xhat[0]) * EKF_U.r_s[0];

   /* '<S2>:1:62' nurm3 = 2*(Xhat(1))*(r_m(3)); */
   nurm3 = (2.0F * EKF_DW.Xhat[0]) * EKF_U.r_m[2];

   /* '<S2>:1:63' nurm2 = 2*(Xhat(1))*(r_m(2)); */
   nurm2 = (2.0F * EKF_DW.Xhat[0]) * EKF_U.r_m[1];

   /* '<S2>:1:64' nurm1 = 2*(Xhat(1))*(r_m(1)); */
   nurm1 = (2.0F * EKF_DW.Xhat[0]) * EKF_U.r_m[0];

   /* '<S2>:1:66' H = [	e3rs2 - e2rs3,           e2rs2 + e3rs3, e1rs2 - nurs3 - 2*e2rs1, nurs2 + e1rs3 - 2*e3rs1, 1, 0, 0, 0, 0, 0; */
   /* '<S2>:1:67'             e1rs3 - e3rs1, nurs3 - 2*e1rs2 + e2rs1,           e1rs1 + e3rs3, e2rs3 - nurs1 - 2*e3rs2, 0, 1, 0, 0, 0, 0; */
   /* '<S2>:1:68'             e2rs1 - e1rs2, e3rs1 - 2*e1rs3 - nurs2, nurs1 - 2*e2rs3 + e3rs2,           e1rs1 + e2rs2, 0, 0, 1, 0, 0, 0; */
   /* '<S2>:1:69'             e3rm2 - e2rm3,           e2rm2 + e3rm3, e1rm2 - nurm3 - 2*e2rm1, nurm2 + e1rm3 - 2*e3rm1, 0, 0, 0, 1, 0, 0; */
   /* '<S2>:1:70'             e1rm3 - e3rm1, nurm3 - 2*e1rm2 + e2rm1,           e1rm1 + e3rm3, e2rm3 - nurm1 - 2*e3rm2, 0, 0, 0, 0, 1, 0; */
   /* '<S2>:1:71'             e2rm1 - e1rm2, e3rm1 - 2*e1rm3 - nurm2, nurm1 - 2*e2rm3 + e3rm2,           e1rm1 + e2rm2, 0, 0, 0, 0, 0, 1]; */
   H[0] = e3rs2 - e2rs3;
   H[6] = e2rs2 + e3rs3;
   H[12] = (e1rs2 - nurs3) - (2.0F * e2rs1);
   H[18] = (nurs2 + e1rs3) - (2.0F * e3rs1);
   H[24] = 1.0F;
   H[30] = 0.0F;
   H[36] = 0.0F;
   H[42] = 0.0F;
   H[48] = 0.0F;
   H[54] = 0.0F;
   H[1] = e1rs3 - e3rs1;
   H[7] = (nurs3 - (2.0F * e1rs2)) + e2rs1;
   H[13] = e1rs1 + e3rs3;
   H[19] = (e2rs3 - nurs1) - (2.0F * e3rs2);
   H[25] = 0.0F;
   H[31] = 1.0F;
   H[37] = 0.0F;
   H[43] = 0.0F;
   H[49] = 0.0F;
   H[55] = 0.0F;
   H[2] = e2rs1 - e1rs2;
   H[8] = (e3rs1 - (2.0F * e1rs3)) - nurs2;
   H[14] = (nurs1 - (2.0F * e2rs3)) + e3rs2;
   H[20] = e1rs1 + e2rs2;
   H[26] = 0.0F;
   H[32] = 0.0F;
   H[38] = 1.0F;
   H[44] = 0.0F;
   H[50] = 0.0F;
   H[56] = 0.0F;
   H[3] = e3rm2 - e2rm3;
   H[9] = e2rm2 + e3rm3;
   H[15] = (e1rm2 - nurm3) - (2.0F * e2rm1);
   H[21] = (nurm2 + e1rm3) - (2.0F * e3rm1);
   H[27] = 0.0F;
   H[33] = 0.0F;
   H[39] = 0.0F;
   H[45] = 1.0F;
   H[51] = 0.0F;
   H[57] = 0.0F;
   H[4] = e1rm3 - e3rm1;
   H[10] = (nurm3 - (2.0F * e1rm2)) + e2rm1;
   H[16] = e1rm1 + e3rm3;
   H[22] = (e2rm3 - nurm1) - (2.0F * e3rm2);
   H[28] = 0.0F;
   H[34] = 0.0F;
   H[40] = 0.0F;
   H[46] = 0.0F;
   H[52] = 1.0F;
   H[58] = 0.0F;
   H[5] = e2rm1 - e1rm2;
   H[11] = (e3rm1 - (2.0F * e1rm3)) - nurm2;
   H[17] = (nurm1 - (2.0F * e2rm3)) + e3rm2;
   H[23] = e1rm1 + e2rm2;
   H[29] = 0.0F;
   H[35] = 0.0F;
   H[41] = 0.0F;
   H[47] = 0.0F;
   H[53] = 0.0F;
   H[59] = 1.0F;

   /*    Uppdating rotation from NED to body to do the nonlinear y=Hx estimate */
   /* '<S2>:1:75' nue1 = Xhat(1) * Xhat(2); */
   e1rs3 = EKF_DW.Xhat[0] * EKF_DW.Xhat[1];

   /* '<S2>:1:76' nue2 = Xhat(1) * Xhat(3); */
   e1rs2 = EKF_DW.Xhat[0] * EKF_DW.Xhat[2];

   /* '<S2>:1:77' nue3 = Xhat(1) * Xhat(4); */
   e1rs1 = EKF_DW.Xhat[0] * EKF_DW.Xhat[3];

   /* '<S2>:1:79' e1e1 = Xhat(2)^2; */
   e1rm3 = EKF_DW.Xhat[1] * EKF_DW.Xhat[1];

   /* '<S2>:1:80' e1e2 = Xhat(2) * Xhat(3); */
   e1rm2 = EKF_DW.Xhat[1] * EKF_DW.Xhat[2];

   /* '<S2>:1:81' e1e3 = Xhat(2) * Xhat(4); */
   e1rm1 = EKF_DW.Xhat[1] * EKF_DW.Xhat[3];

   /* '<S2>:1:83' e2e2 = Xhat(3)^2; */
   e3rs3 = EKF_DW.Xhat[2] * EKF_DW.Xhat[2];

   /* '<S2>:1:84' e2e3 = Xhat(3) * Xhat(4); */
   e3rs2 = EKF_DW.Xhat[2] * EKF_DW.Xhat[3];

   /* '<S2>:1:85' e3e3 = Xhat(4)^2; */
   e3rs1 = EKF_DW.Xhat[3] * EKF_DW.Xhat[3];

   /* '<S2>:1:87' Rb_n = [    1 - 2*(e3e3 + e2e2),        2*(e1e2 + nue3),        2*(e1e3 - nue2); */
   /* '<S2>:1:88'                     2*(e1e2 - nue3),    1 - 2*(e3e3 + e1e1),        2*(e2e3 + nue1); */
   /* '<S2>:1:89'                     2*(e1e3 + nue2),        2*(e2e3 - nue1),    1 - 2*(e2e2 + e1e1)]; */
   Rb_n[0] = 1.0F - ((e3rs1 + e3rs3) * 2.0F);
   Rb_n[3] = (e1rm2 + e1rs1) * 2.0F;
   Rb_n[6] = (e1rm1 - e1rs2) * 2.0F;
   Rb_n[1] = (e1rm2 - e1rs1) * 2.0F;
   Rb_n[4] = 1.0F - ((e3rs1 + e1rm3) * 2.0F);
   Rb_n[7] = (e3rs2 + e1rs3) * 2.0F;
   Rb_n[2] = (e1rm1 + e1rs2) * 2.0F;
   Rb_n[5] = (e3rs2 - e1rs3) * 2.0F;
   Rb_n[8] = 1.0F - ((e3rs3 + e1rm3) * 2.0F);

   /* % ------------------------ Extended Kalman Filter ------------------------ */
   /* % Uppdating K */
   /* '<S2>:1:99' K   = P*H'/(H*P*H' + single(diag([R(1) R(1) R(1) R(2) R(2) R(2)]))); */
   b_v[0] = EKF_U.R[0];
   b_v[1] = EKF_U.R[0];
   b_v[2] = EKF_U.R[0];
   b_v[3] = EKF_U.R[1];
   b_v[4] = EKF_U.R[1];
   b_v[5] = EKF_U.R[1];
   memset(&d[0L], (int16_T)0.0F, 36U * (sizeof(real32_T)));
   for (j = 0; j < 6; j++) {
      d[j + (6 * j)] = b_v[j];
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 6; i++) {
         K[j + (10 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            K[j + (10 * i)] += EKF_DW.P[(10 * i_0) + j] * H[(6 * i_0) + i];
         }
      }
   }

   for (j = 0; j < 6; j++) {
      for (i = 0; i < 10; i++) {
         H_1[j + (6 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            H_1[j + (6 * i)] += H[(6 * i_0) + j] * EKF_DW.P[(10 * i) + i_0];
         }
      }
   }

   for (j = 0; j < 6; j++) {
      for (i = 0; i < 6; i++) {
         e1rs3 = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            e1rs3 += H_1[(6 * i_0) + j] * H[(6 * i_0) + i];
         }

         H_0[j + (6 * i)] = d[(6 * i) + j] + e1rs3;
      }
   }

   lnglbiecbaimkngl_mrdivide(K, H_0);

   /* % Finding error between measurements and predicted measurments    */
   /* '<S2>:1:104' z_hat = ([Rb_n*r_s ;Rb_n*r_m]+ Xhat(5:10)); */
   for (j = 0; j < 3; j++) {
      Rb_n_0[j] = (Rb_n[j + 6] * EKF_U.r_s[2]) + ((Rb_n[j + 3] * EKF_U.r_s[1]) +
         (Rb_n[j] * EKF_U.r_s[0]));
   }

   for (j = 0; j < 3; j++) {
      Rb_n_1[j] = (Rb_n[j + 6] * EKF_U.r_m[2]) + ((Rb_n[j + 3] * EKF_U.r_m[1]) +
         (Rb_n[j] * EKF_U.r_m[0]));
   }

   Rb_n_2[0] = Rb_n_0[0];
   Rb_n_2[1] = Rb_n_0[1];
   Rb_n_2[2] = Rb_n_0[2];
   Rb_n_2[3] = Rb_n_1[0];
   Rb_n_2[4] = Rb_n_1[1];
   Rb_n_2[5] = Rb_n_1[2];

   /*    v   = ( z - H(x)  )     */
   /* '<S2>:1:106' v   = ( z - z_hat ); */
   /* % Updating estimates */
   /*    Updating Xhat */
   /* '<S2>:1:113' Xhat        = Xhat + K*v; */
   for (j = 0; j < 6; j++) {
      EKF_Y.z_hat[j] = EKF_DW.Xhat[4 + j] + Rb_n_2[j];
      tmp[j] = EKF_U.z_n[j] - EKF_Y.z_hat[j];
   }

   for (j = 0; j < 10; j++) {
      e1rs3 = 0.0F;
      for (i = 0; i < 6; i++) {
         e1rs3 += K[(10 * i) + j] * tmp[i];
      }

      EKF_DW.Xhat[j] += e1rs3;
   }

   /*    Normalizing the quaternion */
   /* '<S2>:1:116' Xhat(1:4)	= Xhat(1:4)/sqrt(Xhat(1:4)'*Xhat(1:4)); */
   e1rs3 = (real32_T)sqrt((((EKF_DW.Xhat[0] * EKF_DW.Xhat[0]) + (EKF_DW.Xhat[1] *
      EKF_DW.Xhat[1])) + (EKF_DW.Xhat[2] * EKF_DW.Xhat[2])) + (EKF_DW.Xhat[3] *
      EKF_DW.Xhat[3]));
   EKF_DW.Xhat[0] /= e1rs3;
   EKF_DW.Xhat[1] /= e1rs3;
   EKF_DW.Xhat[2] /= e1rs3;
   EKF_DW.Xhat[3] /= e1rs3;

   /* Outport: '<Root>/x' incorporates:
    *  MATLAB Function: '<S1>/EKF'
    */
   /*    Setting output */
   /* '<S2>:1:119' x           = Xhat; */
   memcpy(&EKF_Y.x[0L], &EKF_DW.Xhat[0L], 10U * (sizeof(real32_T)));

   /* MATLAB Function: '<S1>/EKF' incorporates:
    *  Inport: '<Root>/Q'
    *  Inport: '<Root>/R'
    *  Inport: '<Root>/W'
    */
   /*  	Updating P */
   /* '<S2>:1:122' temp        = (single(eye(10)) - K*H); */
   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         e1rs3 = 0.0F;
         for (i_0 = 0; i_0 < 6; i_0++) {
            e1rs3 += K[(10 * i_0) + j] * H[(6 * i) + i_0];
         }

         temp[j + (10 * i)] = ((real32_T)b[(10 * i) + j]) - e1rs3;
      }
   }

   /* '<S2>:1:123' P           = temp*P*temp' + K*single(diag([R(1) R(1) R(1) R(2) R(2) R(2)]))*K'; */
   b_v[0] = EKF_U.R[0];
   b_v[1] = EKF_U.R[0];
   b_v[2] = EKF_U.R[0];
   b_v[3] = EKF_U.R[1];
   b_v[4] = EKF_U.R[1];
   b_v[5] = EKF_U.R[1];
   memset(&d[0L], (int16_T)0.0F, 36U * (sizeof(real32_T)));
   for (j = 0; j < 6; j++) {
      d[j + (6 * j)] = b_v[j];
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         temp_0[j + (10 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            temp_0[j + (10 * i)] += temp[(10 * i_0) + j] * EKF_DW.P[(10 * i) +
               i_0];
         }
      }
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 6; i++) {
         H[j + (10 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 6; i_0++) {
            H[j + (10 * i)] += K[(10 * i_0) + j] * d[(6 * i) + i_0];
         }
      }
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         temp_1[j + (10 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            temp_1[j + (10 * i)] += temp_0[(10 * i_0) + j] * temp[(10 * i_0) + i];
         }
      }
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         K_0[j + (10 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 6; i_0++) {
            K_0[j + (10 * i)] += H[(10 * i_0) + j] * K[(10 * i_0) + i];
         }
      }
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         EKF_DW.P[i + (10 * j)] = temp_1[(10 * j) + i] + K_0[(10 * j) + i];
      }
   }

   /* % prediction */
   /* 	Buildding PHI */
   /* '<S2>:1:128' Aq	=  single(1/2*[  0      -W(1)   -W(2)    -W(3); */
   /* '<S2>:1:129'                         W(1)    0       W(3)    -W(2); */
   /* '<S2>:1:130'                         W(2)   -W(3)    0        W(1); */
   /* '<S2>:1:131'                         W(3)    W(2)   -W(1)     0   ]); */
   /* '<S2>:1:134' PHI	= single([  eye(4)+h/2*Aq   zeros(4,6) ; */
   /* '<S2>:1:135'                     zeros(6,4)      eye(6)     ]); */
   for (j = 0; j < 16; j++) {
      I[j] = 0;
   }

   I[0] = 1;
   I[5] = 1;
   I[10] = 1;
   I[15] = 1;
   e1rs3 = EKF_U.h / 2.0F;
   memset(&b_I[0L], 0, 36U * (sizeof(int8_T)));
   for (j = 0; j < 6; j++) {
      b_I[j + (6 * j)] = 1;
   }

   tmp_0[0] = 0.0F;
   tmp_0[4] = -EKF_U.W[0];
   tmp_0[8] = -EKF_U.W[1];
   tmp_0[12] = -EKF_U.W[2];
   tmp_0[1] = EKF_U.W[0];
   tmp_0[5] = 0.0F;
   tmp_0[9] = EKF_U.W[2];
   tmp_0[13] = -EKF_U.W[1];
   tmp_0[2] = EKF_U.W[1];
   tmp_0[6] = -EKF_U.W[2];
   tmp_0[10] = 0.0F;
   tmp_0[14] = EKF_U.W[0];
   tmp_0[3] = EKF_U.W[2];
   tmp_0[7] = EKF_U.W[1];
   tmp_0[11] = -EKF_U.W[0];
   tmp_0[15] = 0.0F;
   for (j = 0; j < 4; j++) {
      temp[10 * j] = ((tmp_0[j << 2] * 0.5F) * e1rs3) + ((real32_T)I[j << 2]);
      temp[1 + (10 * j)] = ((tmp_0[(j << 2) + 1] * 0.5F) * e1rs3) + ((real32_T)
         I[(j << 2) + 1]);
      temp[2 + (10 * j)] = ((tmp_0[(j << 2) + 2] * 0.5F) * e1rs3) + ((real32_T)
         I[(j << 2) + 2]);
      temp[3 + (10 * j)] = ((tmp_0[(j << 2) + 3] * 0.5F) * e1rs3) + ((real32_T)
         I[(j << 2) + 3]);
   }

   for (j = 0; j < 6; j++) {
      temp[10 * (j + 4)] = 0.0F;
      temp[1 + (10 * (j + 4))] = 0.0F;
      temp[2 + (10 * (j + 4))] = 0.0F;
      temp[3 + (10 * (j + 4))] = 0.0F;
   }

   for (j = 0; j < 4; j++) {
      for (i = 0; i < 6; i++) {
         temp[(i + (10 * j)) + 4] = 0.0F;
      }
   }

   for (j = 0; j < 6; j++) {
      for (i = 0; i < 6; i++) {
         temp[(i + (10 * (j + 4))) + 4] = b_I[(6 * j) + i];
      }
   }

   /*    Predict Xhat */
   /* '<S2>:1:139' Xhat        = PHI*Xhat; */
   for (j = 0; j < 10; j++) {
      temp_2[j] = 0.0F;
      for (i = 0; i < 10; i++) {
         temp_2[j] += temp[(10 * i) + j] * EKF_DW.Xhat[i];
      }
   }

   memcpy(&EKF_DW.Xhat[0L], &temp_2[0L], 10U * (sizeof(real32_T)));

   /*    Normalizing the quaternion */
   /* '<S2>:1:142' Xhat(1:4)	=	Xhat(1:4)/sqrt(Xhat(1:4)'*Xhat(1:4)); */
   e1rs3 = (real32_T)sqrt((((EKF_DW.Xhat[0] * EKF_DW.Xhat[0]) + (EKF_DW.Xhat[1] *
      EKF_DW.Xhat[1])) + (EKF_DW.Xhat[2] * EKF_DW.Xhat[2])) + (EKF_DW.Xhat[3] *
      EKF_DW.Xhat[3]));
   EKF_DW.Xhat[0] /= e1rs3;
   EKF_DW.Xhat[1] /= e1rs3;
   EKF_DW.Xhat[2] /= e1rs3;
   EKF_DW.Xhat[3] /= e1rs3;

   /*    Predict P */
   /* '<S2>:1:145' P           =	PHI*P*PHI' + single(diag([Q(1) Q(1) Q(1) Q(1) Q(2) Q(2) Q(2) Q(3) Q(3) Q(3)])); */
   v[0] = EKF_U.Q[0];
   v[1] = EKF_U.Q[0];
   v[2] = EKF_U.Q[0];
   v[3] = EKF_U.Q[0];
   v[4] = EKF_U.Q[1];
   v[5] = EKF_U.Q[1];
   v[6] = EKF_U.Q[1];
   v[7] = EKF_U.Q[2];
   v[8] = EKF_U.Q[2];
   v[9] = EKF_U.Q[2];
   memset(&K_0[0L], (int16_T)0.0F, 100U * (sizeof(real32_T)));
   for (j = 0; j < 10; j++) {
      K_0[j + (10 * j)] = v[j];
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         temp_0[j + (10 * i)] = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            temp_0[j + (10 * i)] += temp[(10 * i_0) + j] * EKF_DW.P[(10 * i) +
               i_0];
         }
      }
   }

   for (j = 0; j < 10; j++) {
      for (i = 0; i < 10; i++) {
         e1rs3 = 0.0F;
         for (i_0 = 0; i_0 < 10; i_0++) {
            e1rs3 += temp_0[(10 * i_0) + j] * temp[(10 * i_0) + i];
         }

         EKF_DW.P[j + (10 * i)] = K_0[(10 * i) + j] + e1rs3;
      }
   }

   /* % ---------------------------- end -------------------------------------- */
}

/* Model initialize function */
void EKF_initialize(void)
{
   /* (no initialization code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
