/*
 * File: EKF.h
 *
 * Code generated for Simulink model 'EKF'.
 *
 * Model version                  : 1.121
 * Simulink Coder version         : 8.6 (R2014a) 27-Dec-2013
 * C/C++ source code generated on : Tue Dec 16 03:58:53 2014
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives:
 *    1. Execution efficiency
 *    2. Safety precaution
 *    3. RAM efficiency
 *    4. MISRA-C:2004 guidelines
 * Validation result: Passed (21), Warning (1), Error (0)
 */

#ifndef RTW_HEADER_EKF_h_
#define RTW_HEADER_EKF_h_
#include <math.h>
#include <string.h>
#ifndef EKF_COMMON_INCLUDES_
# define EKF_COMMON_INCLUDES_
#include "rtwtypes.h"
#endif                                 /* EKF_COMMON_INCLUDES_ */

#include "EKF_types.h"
#include "lnglbiecbaimkngl_mrdivide.h"

/* Macros for accessing real-time model data structure */

/* Block signals and states (auto storage) for system '<Root>' */
typedef struct {
   real32_T Xhat[10];                  /* '<S1>/EKF' */
   real32_T P[100];                    /* '<S1>/EKF' */
   boolean_T Xhat_not_empty;           /* '<S1>/EKF' */
} DW_EKF_T;

/* External inputs (root inport signals with auto storage) */
typedef struct {
   real32_T z_n[6];                    /* '<Root>/z_n' */
   real32_T W[3];                      /* '<Root>/W' */
   real32_T h;                         /* '<Root>/h' */
   real32_T Q[3];                      /* '<Root>/Q' */
   real32_T R[2];                      /* '<Root>/R' */
   real32_T P_0[2];                    /* '<Root>/P_0' */
   real32_T r_s[3];                    /* '<Root>/r_s' */
   real32_T r_m[3];                    /* '<Root>/r_m' */
   real32_T q_0[4];                    /* '<Root>/q_0' */
} ExtU_EKF_T;

/* External outputs (root outports fed by signals with auto storage) */
typedef struct {
   real32_T x[10];                     /* '<Root>/x' */
   real32_T z_hat[6];                  /* '<Root>/z_hat' */
} ExtY_EKF_T;

/* Block signals and states (auto storage) */
extern DW_EKF_T EKF_DW;

/* External inputs (root inport signals with auto storage) */
extern ExtU_EKF_T EKF_U;

/* External outputs (root outports fed by signals with auto storage) */
extern ExtY_EKF_T EKF_Y;

/* Model entry point functions */
extern void EKF_initialize(void);
extern void EKF_step(void);

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Note that this particular code originates from a subsystem build,
 * and has its own system numbers different from the parent model.
 * Refer to the system hierarchy for this subsystem below, and use the
 * MATLAB hilite_system command to trace the generated code back
 * to the parent model.  For example,
 *
 * hilite_system('EKF_SIMandSIL/EKF')    - opens subsystem EKF_SIMandSIL/EKF
 * hilite_system('EKF_SIMandSIL/EKF/Kp') - opens and selects block Kp
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'EKF_SIMandSIL'
 * '<S1>'   : 'EKF_SIMandSIL/EKF'
 * '<S2>'   : 'EKF_SIMandSIL/EKF/EKF'
 */

/*-
 * Requirements for '<Root>': EKF
 */
#endif                                 /* RTW_HEADER_EKF_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
