/*
 * estimator.c
 *
 * Created: 17.03.2015 16:57:19
 *  Author: mariuwes
 */ 

#include "estimator.h"

#define PI 3.1415926535F

int estimator_get(int16_t gyroscope_data[12], int16_t magnetometer_data[12], int16_t sun_sensor_data[16], float estiamtor_data[11]) {
	
	for (uint8_t i = 0; i<6 ; i++){
	sun_vect_U.In1[i] = sun_sensor_data[i+6];
	}
	for (uint8_t i = 0; i<3 ; i++){
	normlize_U.in[i] = magnetometer_data[i];	//EKF_U.z_n[i+3] = [m_x m_y m_z]
	}

	normlize_step();
	sun_vect_step();// this builds and normalizes a sun vector [s_x s_y s_z]

	for (uint8_t i = 0; i<3 ; i++){
	EKF_U.W[i] = ((real32_T)gyroscope_data[i]*0.00875F*PI)/(180.0F) ;	//EKF_U.W[] = [w_x w_y w_z]	scaling and converting to r/s gyroscope this is not compensated for the fact that the instrument is not at the center of mass
	EKF_U.z_n[i] = sun_vect_Y.Out1[i];	//sun_vect_Y.Out1[] = [s_x s_y s_z]
	EKF_U.z_n[i+3] = normlize_Y.Out[i];
	}

	EKF_U.P_0[0] = 1.0F;
	EKF_U.P_0[1] = 0.00000001F;
	EKF_U.r_m[0]=1.0F;//-0.36F;
	EKF_U.r_m[1]=0.0F;//-0.01F;
	EKF_U.r_m[2]=0.0F;//0.93F;

	EKF_U.r_s[0]= 0.0F;
	EKF_U.r_s[1]=-1.0F;
	EKF_U.r_s[2]= 0.0F;

	EKF_U.h = 0.292F;
	static const float Q[3] = {0.0009F, 0.000000000001F, 0.0000000000001F}; // i am considering to pack this into a set/input function to make it safer and cleaner
	static const float R[2] = {0.00080F, 0.00004F,}; // [sun mag]
	static const float q_0[4] = {1.0F, 0.0F, 0.0F, 0.0F};
	memcpy(EKF_U.Q,Q,sizeof(Q));
	memcpy(EKF_U.R,R,sizeof(R));
	memcpy(EKF_U.q_0,q_0,sizeof(q_0));


	EKF_step();
	
	return 42;
}