/*
 * File: Normalizing.c
 *
 * Code generated for Simulink model 'Normalizing'.
 *
 * Model version                  : 1.16
 * Simulink Coder version         : 8.6 (R2014a) 27-Dec-2013
 * C/C++ source code generated on : Wed Oct 15 21:16:09 2014
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives:
 *    1. Execution efficiency
 *    2. MISRA-C:2004 guidelines
 *    3. Safety precaution
 * Validation result: Not run
 */

#include "sun_vect.h"
#include "sun_vect_private.h"

/* External inputs (root inport signals with auto storage) */
ExtU_sun_vect_T sun_vect_U;

/* External outputs (root outports fed by signals with auto storage) */
ExtY_sun_vect_T sun_vect_Y;

/* Model step function */
void sun_vect_step(void)
{
  real32_T y;
  int16_T rtb_nsun_vect_idx_0;
  int16_T rtb_nsun_vect_idx_1;
  int16_T rtb_nsun_vect_idx_2;
  int32_T tmp;

  /* MATLAB Function: '<Root>/NORMalizing' incorporates:
   *  Inport: '<Root>/In1'
   */
  /* MATLAB Function 'NORMalizing': '<S1>:1' */
  /* from meas to vector */
  /* '<S1>:1:3' */
  tmp = ((int32_T)sun_vect_U.In1[0]) - sun_vect_U.In1[1];
  if (tmp > 32767L) {
    tmp = 32767L;
  } else {
    if (tmp < -32768L) {
      tmp = -32768L;
    }
  }

  rtb_nsun_vect_idx_0 = (int16_T)tmp;
  tmp = ((int32_T)sun_vect_U.In1[2]) - sun_vect_U.In1[3];
  if (tmp > 32767L) {
    tmp = 32767L;
  } else {
    if (tmp < -32768L) {
      tmp = -32768L;
    }
  }

  rtb_nsun_vect_idx_1 = (int16_T)tmp;
  tmp = ((int32_T)sun_vect_U.In1[4]) - sun_vect_U.In1[5];
  if (tmp > 32767L) {
    tmp = 32767L;
  } else {
    if (tmp < -32768L) {
      tmp = -32768L;
    }
  }

  rtb_nsun_vect_idx_2 = (int16_T)tmp;

  /* normalising vector */
  /* '<S1>:1:5' */
  y = (real32_T)sqrt( ( ((real32_T)(((int32_T)rtb_nsun_vect_idx_0) *rtb_nsun_vect_idx_0)) + 
					    ((real32_T)(((int32_T)rtb_nsun_vect_idx_1) *rtb_nsun_vect_idx_1))) + 
					    ((real32_T)(((int32_T)rtb_nsun_vect_idx_2) *rtb_nsun_vect_idx_2)) );

  /* Outport: '<Root>/Out1' incorporates:
   *  MATLAB Function: '<Root>/NORMalizing'
   */
  sun_vect_Y.Out1[0] = ((real32_T)rtb_nsun_vect_idx_0) / y;
  sun_vect_Y.Out1[1] = ((real32_T)rtb_nsun_vect_idx_1) / y;
  sun_vect_Y.Out1[2] = ((real32_T)rtb_nsun_vect_idx_2) / y;
}
