/*
 * gyroscope.c
 *
 * Created: 20.11.2013 15:53:18
 *  Author: yvind Rein
 */ 
/*
#include <avr/io.h>
#include "gyroscope.h"

void set(uint8_t reg, uint8_t byte);
uint8_t get(uint8_t reg);
 

int gyroscope_initialize(){
	
	// Port and SPI setup
	PORTD_DIR &= ~ 0b01000000;
	
	PORTD_DIRSET |= 0xB0; // SPI and control pins
	PORTD_OUTSET |= 0x10;  // Init. output values
	
	SPID_CTRL &= ~SPI_DORD_bm; // Sets data order to most-significant bit (MSB) first
	SPID_CTRL |= SPI_MASTER_bm; // Select master mode
	SPID_CTRL |= SPI_MODE_3_gc; // SPI mode 3, Leading edge is falling. Samples are read on rising edge.
	SPID_CTRL |= SPI_PRESCALER_DIV16_gc; // 32 mhZ/16 = 2 mHz.  Max frequency for L3G4200D is 10mHz
	SPID_CTRL |= SPI_ENABLE_bm; // Enables SPI
	
	//L3G4200D setup
	
	uint8_t reg  = GY_REG1;
	// Set data output rate to 100Hz. Set bandwidth such that the signal is Low Pass filtered at 12.5 Cut-Off frequency. See datasheet for details.
	uint8_t byte = GY_REG1_PD_normal | GY_REG1_bandwidth_00 | GY_REG1_DR_100; 
	set(reg, byte);
	
	reg = GY_REG4;
	byte = GY_REG4_continuous | GY_REG4_250dps;  // Set continuous sampling. Set to finest resolution possible.
	set(reg, byte);
	
	
	return 1;
}

// data has the length of 3 int16_t. The result will be put into data. data[0]= X, data[1]= Y and data[2]= Z
// The coordinate system is positive in the direction coils are mounted, and z is the coil with smallest area.
// this results in the remapping seen in the function bellow: 
int gyroscope_poll(int16_t data[3]){ 
	data[0] =  (get(GY_Y_H)<<8) + get(GY_Y_L);
	data[1] =  -((get(GY_X_H)<<8) + get(GY_X_L));
	data[2] =  (get(GY_Z_H)<<8) + get(GY_Z_L) + 85;  // hardware bias?
	return 1; 
}


void set(uint8_t reg, uint8_t byte){
	 PORTD_OUT &= ~0b00010000; // Chip select low
	 SPID_DATA = reg;
	 while(!((SPID_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 SPID_DATA = byte;
	 while(!((SPID_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 PORTD_OUTSET |= 0b00010000; // Chip select high
	 return;
 }

uint8_t get(uint8_t reg){
	 PORTD_OUT &= ~0b00010000; // Chip select low
	 SPID_DATA = reg + 0x80; // 0x08 = 0b1000000. First bit is 1 for reading
	 while(!((SPID_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 SPID_DATA = 0x00;
	 while(!((SPID_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 PORTD_OUTSET |= 0b00010000; // Chip select high
	 return SPID_DATA; 
}

int gyroscope_temp(int16_t *temp){
	temp[0]  = get(GY_OUT_TEMP); 
	return 1;
}
*/

#include "gyroscope.h"

int gyroscope_initialize(){

return 42;
}

int gyroscope_poll(int16_t data[12]) {
	
	data[0] = 0;
	data[1] = 0;
	data[2] = 0;
	data[3] = 20;
	data[4] = 20;
	data[5] = 20;
	data[6] = 40;
	data[7] = 40;
	data[8] = 40;
	data[9] = 60;
	data[10] = 60;
	data[11] = 60;
	
	return 42;
}

int gyroscope_temp(int16_t *temp){
	
	temp[0]  = 22;
	
	return 42;
}