/*
 * magnetometer.c
 *
 * Created: 20.11.2013 08:28:08
 *  Author: yvind Rein
 */ 
/*
#include <avr/io.h>
#include "magnetometer.h"
#include <util/delay.h>
// The magnetometer, HMC5983, is connected to SPI in port C

 void mag_set(uint8_t reg, uint8_t byte);
 uint8_t mag_get(uint8_t reg);
 
int magnetometer_initialize(){
	// Port and SPI setup
	PORTC_DIR &= ~ 0b01000000;
	
	PORTC_DIRSET |= 0xB0; // SPI and control pins TODO: These values might be uncorrect
	PORTC_OUTSET |= 0x10;  // Init. output values
	
	SPIC_CTRL &= ~SPI_DORD_bm; // Sets data order to most-significant bit (MSB) first
	SPIC_CTRL |= SPI_MASTER_bm; // Select master mode
	SPIC_CTRL |= SPI_MODE_3_gc; // SPI mode 3, Leading edge is falling. Samples are read on rising edge.  
	SPIC_CTRL |= SPI_PRESCALER_DIV16_gc; // 32 mhZ/16 = 2 mHz.  Max frequency for HMC5983 is 8mHz
	//SPIC_CTRL |= SPI_PRESCALER_DIV128_gc; // 32 mhZ/128 = 250 kHz.  Max frequency for HMC5983 is 8mHz
	SPIC_CTRL |= SPI_ENABLE_bm; // Enables SPI
	
	_delay_ms(500);
	// HMC5983 setup
	//configuration Register A, 0x00
	//if (mag_get(MAG_ID_REGA) != "h"){
	//	return 0; 
	//}
	
	mag_set(MAG_REGA, (MAG_REGA_data_avg_0 | MAG_REGA_temp)); // No sample averaging, Temperature Compensation enabled.
	mag_set(MAG_REGB, MAG_REGB_gain_230); // Gain is set to 230	
	return 1;
}

 void mag_set(uint8_t reg, uint8_t byte){
	 PORTC_OUT &= ~0b00010000; // Chip select low
	 SPIC_DATA = reg;
	 while(!((SPIC_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 SPIC_DATA = byte;
	 while(!((SPIC_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 PORTC_OUTSET |= 0b00010000; // Chip select high
	 return;
 }

 uint8_t mag_get(uint8_t reg){
	 PORTC_OUT &= ~0b00010000; // Chip select active low
	 SPIC_DATA = reg + 0x80;  // 0x80 = 0b1000000. First bit is 1 for reading
	 while(!((SPIC_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 SPIC_DATA = 0x00;
	 while(!((SPIC_STATUS & SPI_IF_bm) == SPI_IF_bm));
	 PORTC_OUTSET |= 0b00010000; // Chip select high
	 return SPIC_DATA;
 }

int magnetometer_poll(int16_t data[3]){ // Stores X, Y, and Z measurements into "data". Returns 0 if no data is ready within a certain amount of tries (MAG_MAX_TRIES)
	mag_set(MAG_MODE, MAG_MODE_single); // Initiate a single measurement
	int tries = 0;
	while ((mag_get(MAG_STATUS_REG) & MAG_STATUS_REG_rdy)){ // Testing shows that this loop runs 50 times.
		tries += 1;
		if (tries > MAG_MAX_TRIES){
			return 0;
		}
	}
	while (!(mag_get(MAG_STATUS_REG) & MAG_STATUS_REG_rdy)){ // Wait for the data to be ready. Testing shows that this loop runs 2 or 3 times. 
		tries += 1;
		if (tries > MAG_MAX_TRIES){
			return 0;
		}
	}
	
	data[0]	 = (mag_get(MAG_DYRA)<<8) + mag_get(MAG_DYRB); // Negative sign so that the axis is correct relative to the satellites BODY frame
	data[1]	 = (mag_get(MAG_DXRA)<<8) + mag_get(MAG_DXRB); // Positive sign so that the axis is correct relative to the satellites BODY frame
	data[1] *=-1;
	data[2]  = (mag_get(MAG_DZRA)<<8) + mag_get(MAG_DZRB); // Negative sign so that the axis is correct relative to the satellites BODY frame
	return 1;	
}

int magnetometer_temp(int16_t * temp){ //Temperature = (MSB * 2^8 + LSB) / (2^4 * 8) + 25 in C
	*temp = ((mag_get(MAG_TEMPA)<<8) + mag_get(MAG_TEMPB))/(128) + 25;
	return 1;
}

*/

#include "magnetometer.h"

int magnetometer_initialize() {
	
	return 42;
}

int magnetometer_poll(int16_t data[12]) {
	
	data[0] = 0;
	data[1] = 0;
	data[2] = 0;
	data[3] = 200;
	data[4] = 200;
	data[5] = 200;
	data[6] = 400;
	data[7] = 400;
	data[8] = 400;
	data[9] = 600;
	data[10] = 600;
	data[11] = 600;
	
	return 42;
}

int magnetometer_temp(int16_t * temp) { 
	
	temp[0] = 22;
	
	return 42;
}

