/*
 * magPred.h
 *
 *  Created: Feb 17, 2015 3:11:10 PM
 *  Author: Antoine Pignede
 *
 *  This file declares the Geomagnetic Vector Prediction.
 *  Two different models, the International Geomagnetic Reference Field (IGRF)
 *    and the World Magnetic Model (WMM), are used.
 *    It is recommended to use the WMM as it prooved to be faster in the testing
 *    phase on the microcontroller, but both models are equally reliable.
 */

#ifndef MAGPRED_H_
#define MAGPRED_H_

	void magIgrf(double reci[3], Time timeUTC, double Beci[3]);
	void magWmm(double reci[3], Time timeUTC, double Beci[3]);

#endif /* MAGPRED_H_ */
