/*
 * predictor.c
 *
 * Created: 17.03.2015 16:57:42
 *  Author: Marius Westgaard
 */ 

#include "predictor.h"
#include "magPred.h"
#include "orbitPred.h"
#include "sunPred.h"
#include <string.h>

char tle[139];
Satrec satrec; 

int predictor_initialize() {
	
	char tle_init[139] = "1 29499U 06044A   15089.19600307  .00000210  00000-0  11573-3 0  99992 29499  98.6843 149.8513 0001703  70.8372 355.9759 14.21500251438067";
	strcpy(tle, tle_init);
	satrec = orbitTwoline2rv(tle);
	
	return 42;
}

int predictor_get_data(Time time, double data[12]) {
	
	orbitSgp4(&satrec, time, &data[0], &data[3]);
	magIgrf(&data[0], time, &data[6]);
	sun(time, &data[9]);
		
	return 42;
}

int predictor_update_tle(char tle_update[139]) {
	
	strcpy(tle, tle_update);
	satrec = orbitTwoline2rv(tle);
	
	return 42;
}