/*
 * sun_sensor_init.c
 *
 * Created: 18.10.2013 14:27:27
 *  Author: yvind Rein
 */ 

// The 6 photodiodes are connected to port A

// Axis			pin
// X, positive   63 (PA1)
// X, negative   64 (PA2)
// Y, positive    1 (PA3)
// Y, negative    2 (PA4)
// Z, positive    3 (PA5)
// Z, negative    4 (PA6)
/*

#include <avr/io.h>
#include <stddef.h>
#include "sun_sensor.h"
#include <avr/pgmspace.h>

uint8_t ReadCalibrationByte(uint8_t index);
uint16_t read_adc();

void sun_sensor_initialize(){
	ADCA.CALL = ReadCalibrationByte( offsetof(NVM_PROD_SIGNATURES_t, ADCACAL0) );
	ADCA.CALH = ReadCalibrationByte( offsetof(NVM_PROD_SIGNATURES_t, ADCACAL1) );
	ADCA.CTRLA |= ADC_ENABLE_bm; // Enable ADCA
	ADCA.PRESCALER = ADC_PRESCALER_DIV256_gc; // ADC clock set to 32MHz/256
	ADCA.CTRLB = ADC_RESOLUTION_12BIT_gc; // Set resolution to 12-bit, right-adjusted
	ADCA.REFCTRL = ADC_REFSEL_INT1V_gc | ADC_BANDGAP_bm; // Set reference voltage to internal 1V using bandgap
	ADCA.CH0.CTRL = ADC_CH_INPUTMODE_SINGLEENDED_gc; // single ended input, no gain.
}

int sun_sensor_poll(int16_t data[6]){ // jeg forstr ikke helt hvorfor det brukes int16_t her, read_adc returnerer uint16_t
	ADCA.CH0.MUXCTRL = SS_XP;
	data[0] = read_adc();
	
	ADCA.CH0.MUXCTRL = SS_XN;
	data[1] = read_adc();
	
	ADCA.CH0.MUXCTRL = SS_YP;
	data[2] = read_adc();
	
	ADCA.CH0.MUXCTRL = SS_YN;
	data[3] = read_adc();
	
	ADCA.CH0.MUXCTRL = SS_ZP;
	data[4] = read_adc();
	
	ADCA.CH0.MUXCTRL = SS_ZN;
	data[5] = read_adc();
		
	return 1;		
}
uint16_t read_adc(){
	ADCA.CH0.CTRL |= ADC_CH_START_bm; // start conversation on channel 0
	while(!ADCA.CH0.INTFLAGS);
	ADCA.CH0.INTFLAGS = 0x0f; // The flag is cleared by writing one to the register
	return ADCA.CH0RES; // result  = ((vinp + dv)/vref)*(TOP+1)    TOP = 4095 for 12bit
}

uint8_t ReadCalibrationByte( uint8_t index )
{
	uint8_t result;

	// Load the NVM Command register to read the calibration row.
	//NVM_CMD = NVM_CMD_READ_CALIB_ROW_gc;
	//result = pgm_read_byte(index);

	// Clean up NVM Command register. 
	//NVM_CMD = NVM_CMD_NO_OPERATION_gc;

	return( result );
}

//void sun_sensor_poll(){
//	ADCA.CH0.CTRL |= ADC_CH_START_bm; // start conversation on channel 0
//	while(!ADCA.CH0.INTFLAGS);
//	uint16_t result = ADCA.CH0RES; // result  = ((vinp + dv)/vref)*(TOP+1)    TOP = 4095 for 12bit
//	printf("%u\n", result);
//}

*/

#include "sun_sensor.h"

int sun_sensor_initialize(){
	
	return 42;
}

int sun_sensor_poll(int16_t data[16]) {
	
	data[0] = 100;
	data[1] = 100;
	data[2] = 100;
	data[3] = 100;
	data[4] = 100;
	data[5] = 100;
	data[6] = 100;
	data[7] = 100;
	data[8] = 100;
	data[9] = 100;
	data[10] = 100;
	data[11] = 100;
	data[12] = 100;
	data[13] = 100;
	data[14] = 100;
	data[15] = 100;
	
	return 42;
}