///*
 //* csp_testing.c
 //*
 //* Created: 19.02.2014 11:53:16
 //* Author: EIT ROMTEKNOLOGI GR.5 2014
 //*/ 
//
//#include "csplib/CSP_testing/csp_testing.h"
//#include <stdio.h>
//#include <string.h>
//#include <asf.h>
//#include "FreeRTOS.h"
//#include "portmacro.h" // For tick length information / timers
//#include "task.h"
//#include "status_codes.h"
//#include "csplib/csp_util.h"
//#include "csplib/i2c_csp_glue.h"
//#include "csplib/include/csp/csp_debug.h"
//#include "cli/cli.h"
//
//#include "csp_controller.h"
//
///************************************************************************/
///*                           VARIABLES									*/
///************************************************************************/
//
//// Set the current cubesat module this MCU represents
//#if (MODULE == 0)
	//static const cubesat_module this_module = OBC;
//#elif (MODULE == 1)
	//static const cubesat_module this_module = RAD;
//#elif (MODULE == 2)
	//static const cubesat_module this_module = OTHER;
//#endif
//
//const char *module_list[3] = {"OnBoard Computer(OBC)", "RADIO", "OTHER MODULE"};
//
//
//// Pool of available tests. Contains both the name and reference to a test.
//static test_action available_tests [] = {
////	Test name																						Function name
	//{"Send a big test packet (60 bytes) from OBC to RAD or RAD/OTHER to OBC",						test_send_big_packet},
	//{"Send a small test packet (60 bytes) from RAD to OBC using RDP",								test_send_RDP},
	//{"Bounce a test packet between RAD/OTHER and OBC",												test_packet_bounce_between_two_modules},
	//{"Send 500 test packets (60 bytes) from OBC to RAD or RAD/OTHER to OBC",						test_send_many_packets},
	//{"Send a test packet (60 bytes) and get it returned",											test_send_big_packet_back},
	//{"Start a second listener on this module",														test_setup_multiple_listeners},
	//{"Send test packets from this unit to the other two simultaneously and get replies",			test_run_multiple_senders},
	//{"Send a test packet (60 bytes) to second listener port from OBC to RAD or RAD/OTHER to OBC",	test_send_big_packet_second_port},
	//{"Send a large packet (500 bytes) OBC to RAD or RAD/OTHER to OBC",								test_send_huge_packet},
	//{"Send all stress patterns from RAD/OTHER to OBC",												test_send_stress_pattern},
	//{"Start passing a packet in circle between the three modules OBC, RAD and OTHER",				test_circle_between_three_modules},
	//{"Rapidly send small packets in order to spam the bus",											test_spammer_obc},
	//{"Send packet with critical priority requesting a ping packet in return",						test_high_priority_ping_obc},
	//}
	//}
//};
//
//// Pool of actions to be run when received command from other unit.
//static test_listener_action listener_actions [] = {
////  Listener name								Pass packet to task			Function name
	//{"Default listener behavior",				true,					test_listener_default},							// 0
	//{"Return the received packet",				true,					test_listener_return_packet},					// 1
	//{"Return bounced packet (two modules)",		false,					test_packet_bounce_between_two_modules},		// 2
	//{"Send reply to sender",					true,					test_send_return_message},						// 3
	//{"Reply received from other unit",			false,					test_message_got_returned},						// 4
	//{"Split packet start",						true,					test_recieve_split_packet},						// 5
	//{"Split packet stop",						true,					test_recieve_split_packet},						// 6
	//{"Pass packet to next in circle",			true,					test_listener_circle_between_three_modules},	// 7
	//{"Split packet in progress",				true,					test_recieve_split_packet},						// 8
	//{"Reply to high-priority ping request",		true,					test_high_priority_ping_reply},					// 9
	//{"Check the received stress pattern",		false,					test_check_stress_pattern}						// 10
//};
//
//// Definition of the addresses/ports of the available modules running CSP
//static modules_t test_modules [] = {
	//{OBC_CSP_ADDR,	 OBC_LISTEN_PORT,	OBC_LISTEN_PORT_2,	 OBC_SRC_PORT,	 OBC_SRC_PORT_2,   OBC_I2C_ADDR},
	//{RADIO_CSP_ADDR, RADIO_LISTEN_PORT, RADIO_LISTEN_PORT_2, RADIO_SRC_PORT, RADIO_SRC_PORT_2, RADIO_I2C_ADDR},
	//{OTHER_CSP_ADDR, OTHER_LISTEN_PORT, OTHER_LISTEN_PORT_2, OTHER_SRC_PORT, OTHER_SRC_PORT_2, OTHER_I2C_ADDR}
//};
//
//// Global taskhandles for listen tasks and running of tests
//static xTaskHandle xListenTask = NULL;			// Task used to listen for incoming commands / packets
//static xTaskHandle xListenTask2 = NULL;			// Auxiliary listen task used in some tests
//static xTaskHandle xListenerActionTask = NULL;  // Task used to execute tasks from the listener
//static xTaskHandle xTransferTask = NULL;		// Main task used to initiate tests from shell
//
//// Packet strings
//static char *ping_packet = "PING";
//static char *big_packet = "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";
//static char *random_data = "wYijPWCofidP0Kend1JAFHxksKhQpVx2hf5rzwzvKTIASRDkuNFw";
//static char *very_big_packet = "abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0\
//123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnop\
//qrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdef\
//ghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz01234";
//
//// Other variables
//static volatile bool verbose = false;						// Print all debug info to terminal.  Can be toggled by 'verbose' in shell
//static int num_bounced = 0;									// Number of packages bounced
//static int counter = 0;					
//static volatile uint8_t listener_num;						// Listener number. Not used after initialization
//static int packets_returned[2];								// Number of packages returned with CMD_RETURNED
//static int current_command = 0;								// The current listener command
//
//static int num_stress_patterns_success = 0;					// Number of passed stress pattern tests successful
//static int num_stress_patterns_failed = 0;					// Number of passed stress pattern tests failed
//static bit_pattern_t current_stress_pattern = BIT_PAT_1_IN_7;	// The current stress pattern being received
//static int num_packets_passed_circle = 0;
//static int total_packets_received = 0;
//
//static char split_recieve_buffer[MAX_PACKET_SPLIT_SIZE];	// Buffer for split packets when receiving data
//static char *ptr_to_recv_buffer = split_recieve_buffer;
//static int split_command = 0;								// Used when receiving command packet with data thats is splitted
//
//static int current_packet = 0;								// Current packet when receiving splitted data
//static uint16_t num_packets = 0;							// Number of splitted packets to recieve 
//
//char bit_pattern[NUM_BYTES_BIT_PATTERNS];
//int csp_initialized = false;
//
///************************************************************************/
///*                           COMMON/SETUP								*/
///************************************************************************/
//
//
//void csp_test_init(void){
	//
	//if (MODULE == OTHER){
		//test_default_setup();
		////test_print_available_tests();
	//}
//}
//
//void print_packets_received(){
	//printf("\r{Total packets received: %i}\r\n", total_packets_received);
//}
//
//void test_default_setup(void){
	//if (!csp_initialized){
		//int status = csp_usage_init(CSP_NR_OF_BUFFERED_PACKETS, test_modules[this_module].csp_address, configTSK_ROUTINGTASK_STACK_SIZE);
		//printf("CSP initialization status: %i\r\n", status);
		//
		//// Listener setup
		//xListenTask = NULL;
		//listener_num = FIRST_LISTEN_TASK;
		//int err;
		//if (err = xTaskCreate(&test_listen_all_task, "Listen all task", configTSK_DEBUGTASK_STACK_SIZE, (void*)&listener_num, configTSK_DEBUGTASK_PRIORITY,&xListenTask) != 1){
			//printf("\rERROR creating listener task: %i\r\n", err);
		//}
		//
		//clear_counters();
		//
		//csp_initialized = true;
	//}
	//else {
		//printf("\rCSP already initialized\r\n");
	//}
	//
	//printf("\r\n----------------------------------\r\n");
	//printf("This is module: %s\r\n", module_list[this_module]);
	//printf("CSP-addr: %i I2C-addr: %i Listening port: %i\r\n", test_modules[this_module].csp_address, test_modules[this_module].i2c_address, test_modules[this_module].listen_port);
	//printf("----------------------------------\r\n");
//}
//
//void test_start_test_task(portCHAR * test_nr_str){
	//// Convert test number to integer
	//int test_nr = atoi(test_nr_str);
	//
	//// Check if test number is valid
	//if (test_nr >= 0 && test_nr < (sizeof(available_tests)/sizeof(test_action))){
		//
		//// Try starting the designated test task in FreeRTOS
		//xTransferTask = NULL;
		//int err;
		//if (err = xTaskCreate((void*)&(*available_tests[test_nr].actionPtr), configTSK_TEST_TASK_NAME, configTSK_TEST_TASK_STACK_SIZE, NULL, configTSK_TEST_TASK_PRIORITY,&xTransferTask) != -1){
			//printf("\r\n----------------------------------------------------------------\r\n");
			//printf("Starting test: %s\r\n", available_tests[test_nr].actionName);
			//printf("\r----------------------------------------------------------------\r\n");
		//}
		//else printf("\rError creating task, no test ran\r\n");
		//
		//
		////xTaskCreate((void*)&(*available_tests[test_nr].actionPtr), configTSK_TEST_TASK_NAME, configTSK_TEST_TASK_STACK_SIZE, NULL, configTSK_TEST_TASK_PRIORITY,&xTransferTask);
		////int err = xTaskCreate(&test_send_big_packet, "test-test-test", configMINIMAL_STACK_SIZE+2048, NULL, tskIDLE_PRIORITY+1, NULL);
	//}
	//else {
		//printf("\rThe specified test '%i' does not exist.\r\n", test_nr);
	//}
//}
//
//void test_print_available_tests(void){
	//
	//printf("\r\n----------------------------------\r\n");
	//printf("This is module: %s\r\n", module_list[this_module]);
	//printf("CSP-addr: %i I2C-addr: %i Listening port: %i\r\n", test_modules[this_module].csp_address, test_modules[this_module].i2c_address, test_modules[this_module].listen_port);
	//printf("----------------------------------\r\n");
	//
	//printf("The following tests are available:\r\n");
	//for(int i = 0; i < sizeof(available_tests)/sizeof(test_action); i++){
		//vTaskDelay(10); //CLI may crash without the delay
		//printf("%i. ", i);
		//printf(available_tests[i].actionName);
		//printf("\r\n");
	//}
//}
//
///************************************************************************/
///*                          TEST LISTENER								*/
///************************************************************************/
//
//void test_listen_all_task(void *ptr) {
	//csp_conn_t *conn;
	//uint8_t listen_socket;
	//uint8_t listener_number = *(uint8_t*)ptr;
	//
	//// Set up listen socket
	//switch (listener_number) {
		//case FIRST_LISTEN_TASK:
		//listen_socket = test_modules[this_module].listen_port;
		//break;
		//case SECOND_LISTEN_TASK:
		//listen_socket = test_modules[this_module].listen_port_2;
		//break;
	//}
	//
	//csp_socket_t *sock = test_create_listen_socket(listen_socket);
	//if (sock == NULL) {
		//printf("\rError creating/binding port/socket.\r\n");
		//while(true) {
			//// Stay in task in order to not crash FreeRTOS
		//}
	//}
	//
	//while(true) {
		//conn = csp_accept(sock, CSP_ACCEPT_TIMEOUT);
		//// Print transmission stats when connection is inactive.
		//if (conn == NULL){
			////if (csp_test_mode) print_packets_received();
			////printf("I2C RX: [%is :: %if] | I2C TX: [%is :: %if]\r\n", rx_success, rx_fail, tx_success, tx_fail);
			//clear_counters(); // Clears the rx/tx counters in glue
			//continue;
		//}
		//
		//// Listener loop (waits for packets)
		//while(true){
			////if (verbose)
			////	printf("Checking the received packets.\r\n");
			//csp_packet_t * packet = csp_read(conn, CSP_READ_TIMEOUT);
			//if (packet == NULL){
				//csp_close(conn);
				//break;
			//}
			//
			//// Check for command
			//current_command = 0;
				//
			//if(packet->data[0] == ASCII_ENQ) {
				//// Assign command to the currently running command if it is valid.
				//uint8_t command_number = packet->data[1];
				//
				//if(command_number < 0 || command_number > MAX_COMMANDS){
					//if (verbose)
						//printf("Invalid command '%is' specified.\r\n", command_number);
				//}else{
					//current_command = command_number;
				//}
			//}
			//
			//if (verbose) {
				//printf("\r----------------------------------------------------------------\r\n");
				//printf("Packet received. Current command: %i\r\n", current_command);
			//}
			//
			//// Pass the packet to the currently running command (0 = default behavior)			
			//if (current_command != CMD_DO_NOTHING) {
				//xTransferTask = NULL;
				//
				//if (verbose) 
					//printf("Running test: %s.\r\n", listener_actions[current_command].actionName);
				//
				//if (listener_actions[current_command].needs_packet) {
					//// Creates the task. Packet sent by pointer to task. NB! Packet must be freed after use in the function!
					//xTaskCreate((void*)&(*listener_actions[current_command].actionPtr), configTSK_LISTENER_TASK_NAME, configTSK_TEST_TASK_STACK_SIZE, packet, configTSK_LISTEN_TASK_PRIORITY,&xListenerActionTask);
				//}
				//else {
					//// Creates task with pointer to current listener number, in order to know the source module
					//xTaskCreate((void*)&(*listener_actions[current_command].actionPtr), configTSK_LISTENER_TASK_NAME, configTSK_TEST_TASK_STACK_SIZE, &listener_number, configTSK_LISTEN_TASK_PRIORITY,&xListenerActionTask);
					//csp_buffer_free(packet);
				//}
			//}
			//else {
				//csp_buffer_free(packet);
				//packet = NULL;
			//}
			//total_packets_received++;
			//print_packets_received();
		//}
		//if (conn != NULL)
			//csp_close(conn);
	//}
//}
//
///************************************************************************/
///*                          LISTENER ACTIONS							*/
///************************************************************************/
//
//void test_listener_default(void *ptr){
	//csp_packet_t *packet = (csp_packet_t*)ptr;
	//
	//if (verbose) {
		//printf("Packet: %.*s | ", packet->length, packet->data);
		//printf("Size: %i\r\n", packet->length);
	//}
	//
	//csp_buffer_free(packet);
	//packet = NULL;
	//
	//vTaskDelete(xListenerActionTask);
//}
//
//void test_listener_return_packet(void *ptr){	
	//csp_packet_t *packet = (csp_packet_t*)ptr;
	//
	//int length = packet->length;
	//length -= COMMAND_SIZE; // only return the data, not command
	//csp_packet_t *ret_packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + length);
	//
	//if (ret_packet != NULL && packet != NULL) {
		//memcpy(ret_packet->data, &packet->data[2], length);
		//ret_packet->length = length;
		//
		//if (csp_sendto_reply(packet, ret_packet, CSP_O_NONE, CSP_SEND_TIMEOUT) != CSP_ERR_NONE){
			//csp_buffer_free(ret_packet);
			//printf("Failed_to return packet.\r\n");
		//}
		//else {
			//if (verbose)
				//printf("Returned packet '%.*s'\r\n", ret_packet->length, ret_packet->data);
			//
			//ret_packet = NULL;
		//}
	//}
	//
	//csp_buffer_free(packet);
	//packet = NULL;
	//vTaskDelete(xListenerActionTask);
//}
//
//void test_send_return_message(void *ptr) {
	//csp_packet_t *packet = (csp_packet_t*)ptr;
	//
	//test_send_reply_command(packet, CMD_RETURNED); // Packet freed in this function
	//
	//vTaskDelete(xListenerActionTask);
//}
//
//void test_message_got_returned(void *ptr) {
	//int listener_number = *(int*)ptr;
	//char *module_name;
	//packets_returned[listener_number]++;
	//
	//if (verbose) {
		//switch (this_module) {
			//case OBC:
			//if (listener_number)
				//module_name = "RAD";
			//else
				//module_name = "OTHER";
			//break;
			//case RAD:
			//if (listener_number)
				//module_name = "OBC";
			//else
				//module_name = "OTHER";
			//break;
			//case OTHER:
			//if (listener_number)
				//module_name = "OBC";
			//else
				//module_name = "RAD";
			//break;
		//}
		//printf("'%i' packets returned from %s", packets_returned[listener_number], module_name);
	//}
//
	//vTaskDelete(xListenerActionTask);
//}
//
//void test_recieve_split_packet(void *ptr) {
	//csp_packet_t *packet = (csp_packet_t*)ptr;
	//int packet_size = MAX_PACKET_SIZE;
	//static bool no_error;
	//static int total_size;
	//
	//switch (current_command) {
		//// Init splitting and getting number of packets to be received
		//case CMD_SPLIT_START:
		//current_packet = 0;
		//total_size = 0;
		//no_error = false;
		//split_command = 0;
		//
		//num_packets = packet->data[2];
		//num_packets = (packet->data[3] << 8) | num_packets;
		//
		//// Check if the packet has a command that needs to be run after splitting is complete
		//if (packet->data[4] == ASCII_ENQ) {
			//if (verbose)
				//printf("This is a packet with both data+command\r\n");
			//split_command = packet->data[5];
		//}
		//
		//if (verbose)
			//printf("Starting receiving split packet with size %i.\r\n", num_packets);
		//break;
		//
		//// Getting the packets
		//case CMD_SPLIT:
		//if (verbose)
			//printf("Current receiving packet number: %i\r\n", current_packet);
		//
		//// Copy data to buffer
		//memcpy(ptr_to_recv_buffer+current_packet*MAX_PACKET_SIZE, &packet->data[2], MAX_PACKET_SIZE);
		//
		//// This should be the last packet	
		//if (++current_packet == num_packets) {
			//packet_size = (packet->length)-COMMAND_SIZE-1;
			//
			//// Check for EOT in last byte
			//for (int i=COMMAND_SIZE; i<MAX_PACKET_SIZE+COMMAND_SIZE+1; i++) {
				//if (packet->data[i] == ASCII_EOT) {
					//if (verbose)
						//printf("EOT detected\r\n");
					//no_error = true;
					//break;
				//}
				//// EOT not received
				//else {
					//no_error = false;
				//}
			//}
		//}
	//
		//if (current_packet > num_packets)
			//no_error = false;	
		//
		//total_size += packet_size;
		//
		//if (verbose) {	
			//printf("Packet length: %i\r\n",packet_size);
			//printf("Data '%.*s'\r\n", packet_size, &packet->data[2]);
		//}
		//break;
		//
		//// Received stop packet. Display received packet.
		//case CMD_SPLIT_STOP:
		//if (verbose)
			//printf("Stop packet received.\r\n");
		//
		//if (no_error) {
			//if (verbose) {
				//printf("Splitted complete packet received with size '%i' and data:\r\n", total_size);
				//printf("'%.*s'\r\n", current_packet*MAX_PACKET_SIZE, ptr_to_recv_buffer);
			//}
			//// If a command has been recieved, it must be run now
			//if (split_command != 0 && split_command < MAX_COMMANDS) {
				//if (verbose)
					//printf("Running command: %i\r\n", split_command);
				//listener_actions[split_command].actionPtr(&total_size); // if function needs the packet data, it is in the buffer and accessed directly.
				//if (verbose)
					//printf("Command finished\r\n");
			//}
		//}
		//else {
			//printf("Something went wrong with the splitting/recombining of the transferred packet.\r\n");
		//}
		//break;
	//}
	//
	//csp_buffer_free(packet);
	//packet = NULL;
	//vTaskDelete(xListenerActionTask);
//}
//
//
//void test_high_priority_ping_reply(void *ptr){
	//csp_packet_t *packet = (csp_packet_t*)ptr;
	//csp_packet_t *ret_packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + strlen(ping_packet));
	//
	//if (ret_packet != NULL && packet != NULL) {
		//memcpy(ret_packet->data, ping_packet, strlen(ping_packet));
		//ret_packet->length = strlen(ping_packet);
	//}
	//csp_sendto_reply(packet, ret_packet, CSP_O_NONE, CSP_SEND_TIMEOUT);
	//
	//csp_buffer_free(packet);
	//packet = NULL;
	//vTaskDelete(xListenerActionTask);
//}
//
//void test_listener_circle_between_three_modules(void *ptr){	
	//csp_packet_t *packet = (csp_packet_t*)ptr;
//
	//// Check the incoming packet against reference
	//if (packet != NULL) {
		//if (simple_compare(random_data, (char*)&packet->data[COMMAND_SIZE], packet->length-COMMAND_SIZE)) {
			//if (verbose)
				//printf("Incoming packet identical to reference packet.\r\n");
		//} 
		//else {
			//printf("Incoming packet differs from reference packet!\r\n");
		//}
	//}
	//
	//// Pass the command to the next module in the circle
	//switch (this_module) {
		//case OBC:
		//test_send(COMMAND_PLUS_DATA, &test_modules[RAD], &test_modules[this_module], FIRST_SRC_DEST, random_data, strlen(random_data), CMD_CIRCLE, CSP_PRIO_NORM);
		//break;
		//case RAD:
		//test_send(COMMAND_PLUS_DATA, &test_modules[OTHER], &test_modules[this_module], FIRST_SRC_DEST, random_data, strlen(random_data), CMD_CIRCLE, CSP_PRIO_NORM);
		//break;
		//case OTHER:
		//test_send(COMMAND_PLUS_DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, random_data, strlen(random_data), CMD_CIRCLE, CSP_PRIO_NORM);
		//break;
	//}
	//
	//if (!(++num_packets_passed_circle % 100)) {
		//printf("Successfully passed %i packets to next module in circle.\r\n", num_packets_passed_circle);
	//}
	//
	//csp_buffer_free(packet);
	//packet = NULL;
	//vTaskDelete(xListenerActionTask);
//}
//
//void test_check_stress_pattern(void *ptr){
	//int size = *(int*)ptr;
	//
	//if (num_stress_patterns_success == 0) {
		//// Load stress pattern
		//switch (current_stress_pattern) {
			//case BIT_PAT_1_IN_7:
			//current_stress_pattern = BIT_PAT_ALL_ONES;
			//break;
			//case BIT_PAT_ALL_ONES:
			//current_stress_pattern = BIT_PAT_ALL_ZEROS;
			//break;
			//case BIT_PAT_ALL_ZEROS:
			//current_stress_pattern = BIT_PAT_3_IN_24;
			//break;
			//case BIT_PAT_3_IN_24:
			//current_stress_pattern = BIT_PAT_QRSS;
			//break;
			//case BIT_PAT_QRSS:
			//current_stress_pattern = BIT_PAT_ALT;
			//break;
			//case BIT_PAT_ALT:
			//current_stress_pattern = BIT_PAT_1_IN_7;
			//break;
		//}
		//load_stress_pattern_into_char(current_stress_pattern);
	//}
	//// Check the incoming packet data against reference
	//if (simple_compare(bit_pattern, ptr_to_recv_buffer, size)) {
		//if (verbose)
			//printf("Stress pattern test passed for pattern %i.\r\n", current_stress_pattern);
		//num_stress_patterns_success++;
	//}
	//else {
		//num_stress_patterns_failed++;
		//printf("Stress pattern test failed for pattern type %i, in test iteration %i.\r\n", current_stress_pattern, num_stress_patterns_success+num_stress_patterns_failed);
	//}
	//
	//// Print results if last packet to test
	//if (num_stress_patterns_success == NUM_STRESS_PATTERNS_SENDING) {
		//printf("Successfully received %i stress patterns with pattern type %i\r\n", NUM_STRESS_PATTERNS_SENDING, current_stress_pattern);
		//num_stress_patterns_success = 0;
	//}
	//else if (num_stress_patterns_success+num_stress_patterns_failed == NUM_STRESS_PATTERNS_SENDING) {
		//printf("Successfully received %i stress patterns with pattern type %i. %i stress patterns failed.\r\n", num_stress_patterns_success,current_stress_pattern,num_stress_patterns_failed);
		//num_stress_patterns_success = 0;
	//} 
//}
//
///************************************************************************/
///*                    TEST FUNCTIONS IMPLEMENTATION						*/
///************************************************************************/
//
///* ----------- Main functions --------------*/
//
//void test_setup_multiple_listeners(void) {
	//listener_num = SECOND_LISTEN_TASK;
	//
	//xListenTask2 = NULL;
	//xTaskCreate(&test_listen_all_task, configTSK_DEBUGTASK2_NAME, configTSK_DEBUGTASK2_STACK_SIZE, (void*)&listener_num, configTSK_DEBUGTASK2_PRIORITY,&xListenTask2);
	//
	//vTaskDelete(xTransferTask);
//}
//
//void test_run_multiple_senders(void) {
	//if (xListenTask2 == NULL) {
		//listener_num = SECOND_LISTEN_TASK;
		//xTaskCreate(&test_listen_all_task, configTSK_DEBUGTASK2_NAME, configTSK_DEBUGTASK2_STACK_SIZE, (void*)&listener_num, configTSK_DEBUGTASK2_PRIORITY,&xListenTask2);
	//}
	//while (true) {
		//switch (this_module) {
			//case OBC:
			//test_send(COMMAND, &test_modules[RAD], &test_modules[OBC], FIRST_SRC_DEST, NULL, 0, CMD_RETURN, CSP_PRIO_NORM);
			//test_send(COMMAND, &test_modules[OTHER], &test_modules[OBC], SECOND_SRC_DEST, NULL, 0, CMD_RETURN, CSP_PRIO_NORM);
			//break;
			//case RAD:
			//test_send(COMMAND, &test_modules[OBC], &test_modules[RAD], FIRST_SRC_DEST, NULL, 0, CMD_RETURN, CSP_PRIO_NORM);
			//test_send(COMMAND, &test_modules[OTHER], &test_modules[RAD], SECOND_SRC_DEST, NULL, 0, CMD_RETURN, CSP_PRIO_NORM);
			//break;
			//case OTHER:
			//test_send(COMMAND, &test_modules[OBC], &test_modules[OTHER], FIRST_SRC_DEST, NULL, 0, CMD_RETURN, CSP_PRIO_NORM);
			//test_send(COMMAND, &test_modules[RAD], &test_modules[OTHER], SECOND_SRC_DEST, NULL, 0, CMD_RETURN, CSP_PRIO_NORM);
			//break;
		//}
		//
		//vTaskDelay(1000); // Wait 1 sec
	//}
//}
//void test_packet_bounce_between_two_modules(void) {
	//switch (this_module) {
	//case OBC:
		//test_send(COMMAND, &test_modules[RAD], &test_modules[OBC], FIRST_SRC_DEST, NULL, 0, CMD_BOUNCE, CSP_PRIO_NORM);
		//break;
	//case RAD:
		//test_send(COMMAND, &test_modules[OBC], &test_modules[RAD], FIRST_SRC_DEST, NULL, 0, CMD_BOUNCE, CSP_PRIO_NORM);
		//break;
	//case OTHER:
		//printf("This test only works between OBC and RAD!");
		//break;
	//}
	//num_bounced++;
	//counter++;
	//
	//if (!(counter % 100)) {
		//printf("Number of packages bounced: %i\r\n", num_bounced);
		//counter = 0;
	//}
	//
	//vTaskDelete(xTransferTask);
//}
//
//void test_circle_between_three_modules(void) {
	//switch (this_module) {
		//case OBC:
		//test_send(COMMAND_PLUS_DATA, &test_modules[RAD], &test_modules[OBC], FIRST_SRC_DEST, random_data, strlen(random_data), CMD_CIRCLE, CSP_PRIO_NORM);
		//break;
		//case RAD:
		//test_send(COMMAND_PLUS_DATA, &test_modules[OTHER], &test_modules[RAD], FIRST_SRC_DEST, random_data, strlen(random_data), CMD_CIRCLE, CSP_PRIO_NORM);
		//break;
		//case OTHER:
		//test_send(COMMAND_PLUS_DATA, &test_modules[OBC], &test_modules[OTHER], FIRST_SRC_DEST, random_data, strlen(random_data), CMD_CIRCLE, CSP_PRIO_NORM);
		//break;
	//}
	//vTaskDelete(xTransferTask);
//}
//
//void test_send_stress_pattern(void) {
	//bit_pattern_t curr_pattern = BIT_PAT_1_IN_7;
	//int ret,size;
	//int tests_run = 0;
	//
	//printf("Bit pattern types:\r\n 1 in 7 = '0', all ones = '1', all zeros = '2', 3 in 24 = '3', QRSS = '4', altern. = '5'\r\n");
	//
	//while(true) {
		//for (int j=0; j<NUM_TYPES_STRESS_PATTERNS; j++) {
			//switch (current_stress_pattern) {
				//case BIT_PAT_1_IN_7:
				//current_stress_pattern = BIT_PAT_ALL_ONES;
				//break;
				//case BIT_PAT_ALL_ONES:
				//current_stress_pattern = BIT_PAT_ALL_ZEROS;
				//break;
				//case BIT_PAT_ALL_ZEROS:
				//current_stress_pattern = BIT_PAT_3_IN_24;
				//break;
				//case BIT_PAT_3_IN_24:
				//current_stress_pattern = BIT_PAT_QRSS;
				//break;
				//case BIT_PAT_QRSS:
				//current_stress_pattern = BIT_PAT_ALT;
				//break;
				//case BIT_PAT_ALT:
				//current_stress_pattern = BIT_PAT_1_IN_7;
				//break;
			//}
			//size = load_stress_pattern_into_char(current_stress_pattern);  // Load the pattern into array
		//
			//printf("Sending %i packets with the stress pattern type %i containing %i bytes data.\r\n", NUM_STRESS_PATTERNS_SENDING, current_stress_pattern, size);
		//
			//for (int i=0; i<NUM_STRESS_PATTERNS_SENDING; i++) {
				//switch (this_module) {
					//case OBC:
					//if (verbose)
						//printf("Sending stress pattern to RAD on port %i\r\n", test_modules[RAD].listen_port);
					//ret = test_send(COMMAND_PLUS_DATA, &test_modules[RAD], &test_modules[OBC], FIRST_SRC_DEST, bit_pattern, size, CMD_PATTERN, CSP_PRIO_NORM);
					//break;
					//case RAD:
					//if (verbose)
						//printf("Sending stress pattern to OBC on port %i\r\n", test_modules[OBC].listen_port);
					//ret = test_send(COMMAND_PLUS_DATA, &test_modules[OBC], &test_modules[RAD], FIRST_SRC_DEST, bit_pattern, size, CMD_PATTERN, CSP_PRIO_NORM);
					//break;
					//case OTHER:
					//if (verbose)
						//printf("Sending stress pattern to OBC on port %i\r\n", test_modules[OBC].listen_port);
					//ret = test_send(COMMAND_PLUS_DATA, &test_modules[OBC], &test_modules[OTHER], FIRST_SRC_DEST, bit_pattern, size, CMD_PATTERN, CSP_PRIO_NORM);
					//break;
				//}
				//if (ret != STATUS_OK)
					//printf("Something went wrong with the sending of one of the packets.\r\n");
				//
				////vTaskDelay(200);
			//}
		//}
		//printf("Test run number %i.\r\n", ++tests_run);
	//}
	//vTaskDelete(xTransferTask);
//}
//
//void test_spammer_obc(void) { 
	//char * spam_string = "ThisIsASpamPacket";;  
	//portTickType xDelay = 100;
	//int count = 0;
  //
	//int errorMessage = 0;
	//while(true) {
		//errorMessage = test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, spam_string, strlen(spam_string), NO_COMMAND, CSP_PRIO_NORM);
		//if(errorMessage  == STATUS_OK){
			//count++;
			//if(!(count % 10)) {
				//if (verbose)
					//printf("Spam packet count: %i\r\n", count);
			//}
		//}
		//else
		//{
			//printf("test_send returned error: %i", errorMessage);	
		//}
		//vTaskDelay(xDelay); // delay some between sent packets to not congest
	//}
//}
//
//void test_high_priority_ping_obc(void){
	//portTickType xDelay = 1000;
	//status_code_t status = STATUS_OK;
	//
	//while(true){		
		//status = test_send(COMMAND, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, NULL, 0, CMD_PING_REPLY, CSP_PRIO_CRITICAL);
		//if(status != STATUS_OK){
			//printf("Ping operation returned error code %i\r\n", status);
		//}
		//vTaskDelay(xDelay);
	//}
//}
//
///* ----------- Semi-temporary functions --------------*/
//
//void test_send_big_packet(void) {
	//printf("\rSending big packet\r\n");
	//int err = STATUS_OK;
	//switch (this_module) {
	//case OBC:
		//if (verbose)
			//printf("Sending big packet to address %i on port %i\r\n", test_modules[RAD].csp_address, test_modules[RAD].listen_port);
		//err = test_send(DATA, &test_modules[RAD], &test_modules[this_module], FIRST_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
		//break;
	//case RAD:
		//if (verbose)
			//printf("Sending big packet to address %i on port %i\r\n", test_modules[OBC].csp_address, test_modules[OBC].listen_port);
		//err = test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
		//break;
	//case OTHER:
		//if (verbose)
			//printf("Sending big packet to address %i on port %i\r\n", test_modules[OBC].csp_address, test_modules[OBC].listen_port);
		//err = test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
		//break;
	//}
	////vTaskDelete( NULL );
	//
	//if (err != STATUS_OK) printf("\rSending failed\n");
	//vTaskDelete(xTransferTask);
//}
//
//void test_send_RDP(void) {
	//size_t size = strlen(ping_packet);
	//csp_packet_t *packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + size);
	//
	//// Copy the data to packet and send.
	//if (packet != NULL) {
		//packet->length = size;
		//memcpy(packet->data, ping_packet, size);
		//
	//}
	//
	//if (verbose)
	//printf("Sending small packet with CRC to address %i on port %i\r\n", test_modules[RAD].csp_address, test_modules[RAD].listen_port);
	//if (test_send_packet(&test_modules[OBC].i2c_address, &test_modules[OBC].listen_port, &test_modules[RAD].source_port, CSP_FRDP, packet, CSP_PRIO_NORM) == ERR_IO_ERROR) {
		//printf("Data not sent.\r\n");
	//}
	//else {
		//if (verbose) {
			//printf("Data '%.*s' sent | ", packet->length, packet->data);
			//printf("With length: %i\r\n", packet->length);
		//}
	//}
	//vTaskDelete(xTransferTask);
//}
//
//void test_send_huge_packet(void) {
	//switch (this_module) {
		//case OBC:
			//if (verbose)
				//printf("Sending huge packet to address %i on port %i\r\n", test_modules[RAD].csp_address, test_modules[RAD].listen_port);
			//test_send(DATA, &test_modules[RAD], &test_modules[this_module], FIRST_SRC_DEST, very_big_packet, strlen(very_big_packet), NO_COMMAND, CSP_PRIO_NORM);
			//break;
		//case RAD:
			//if (verbose)
				//printf("Sending huge packet to address %i on port %i\r\n", test_modules[OBC].csp_address, test_modules[OBC].listen_port);
			//test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, very_big_packet, strlen(very_big_packet), NO_COMMAND, CSP_PRIO_NORM);
			//break;
		//case OTHER:
			//if (verbose)
				//printf("Sending huge packet to address %i on port %i\r\n", test_modules[OBC].csp_address, test_modules[OBC].listen_port);
			//test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, very_big_packet, strlen(very_big_packet), NO_COMMAND, CSP_PRIO_NORM);
			//break;
	//}
	//vTaskDelete(xTransferTask);
//}
//
//void test_send_big_packet_second_port(void) {
	//switch (this_module) {
		//case OBC:
			//if (verbose)
				//printf("Sending big packet to address %i on port %i\r\n", test_modules[RAD].csp_address, test_modules[RAD].listen_port_2);
			//test_send(DATA, &test_modules[RAD], &test_modules[this_module], SECOND_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
			//break;
		//case RAD:
			//if (verbose)
				//printf("Sending big packet to address %i on port %i\r\n", test_modules[OBC].csp_address, test_modules[OBC].listen_port_2);
			//test_send(DATA, &test_modules[OBC], &test_modules[this_module], SECOND_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
			//break;
		//case OTHER:
			//if (verbose)
				//printf("Sending big packet to address %i on port %i\r\n", test_modules[OBC].csp_address, test_modules[OBC].listen_port_2);
			//test_send(DATA, &test_modules[OBC], &test_modules[this_module], SECOND_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
			//break;
	//}
	//vTaskDelete(xTransferTask);
//}
//
//void test_send_big_packet_back(void) {
	//test_send_packet_back(big_packet);
	//
	//vTaskDelete(xTransferTask); 
//}
//
//void test_send_many_packets(void) {
	//int ret;
	//printf("Sending %i packets from module %i\r\n", MANY_PACKETS_NUM, this_module);
	//
	//for (int i=0; i<=MANY_PACKETS_NUM; i++) {
		//switch (this_module) {
			//case OBC:
				//ret = test_send(DATA, &test_modules[RAD], &test_modules[this_module], FIRST_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
				//break;
			//case RAD:
				//ret = test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
				//break;
			//case OTHER:
				//ret = test_send(DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, big_packet, strlen(big_packet), NO_COMMAND, CSP_PRIO_NORM);
				//break;
		//}
		//if (ret != STATUS_OK)
			//printf("Sending encountered an error with code %i.\r\n",ret);
	//}
	//printf("500 packets sent.\r\n");
	//
	//vTaskDelete(xTransferTask);
//}
//
///************************************************************************/
///*                           TEST HELPER FUNCTIONS                      */
///************************************************************************/
//
//void test_send_packet_back(char *data) {
	//switch (this_module) {
		//case OBC:
			//test_send(COMMAND_PLUS_DATA, &test_modules[RAD], &test_modules[this_module], FIRST_SRC_DEST, data, strlen(data), CMD_SEND_BACK, CSP_PRIO_NORM);
			//break;
		//case RAD:
			//test_send(COMMAND_PLUS_DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, data, strlen(data), CMD_SEND_BACK, CSP_PRIO_NORM);
			//break;
		//case OTHER:
			//test_send(COMMAND_PLUS_DATA, &test_modules[OBC], &test_modules[this_module], FIRST_SRC_DEST, data, strlen(data), CMD_SEND_BACK, CSP_PRIO_NORM);
			//break;
	//}
//}
//
//int test_send(packet_type_t type, modules_t *dest_module, modules_t *from_module, first_second_port_t port_num, char *data, int size, command_t command, csp_prio_t priority) {
	//int retval[3] = {1};
	//static uint16_t num_packets;
	//
	//// Get the right source/destination port for modules
	//uint8_t *dest_port = test_get_first_second_port(dest_module, port_num, DEST);
	//uint8_t *src_port = test_get_first_second_port(from_module, port_num, SRC);  
	//
	//printf("\rSending to port %i from port %i\n\r", *dest_port, *src_port);
	//
	//// Use different approaches for the different packet types
	//switch(type) {
		//case COMMAND:
		//retval[0] = test_send_command(&dest_module->i2c_address, dest_port, src_port, command, priority);
		//break;
		//case DATA:
		//// Check if packet has to be split
		//if (size > MAX_PACKET_SIZE) {
			//if (verbose) {
				//printf("Sending data: '%s'\r\n", data);
				//printf("This data has size '%i', which is too large to fit in one packet. Using splitting/recombining.\r\n", size);
			//}
			//
			//if (!(size % (MAX_PACKET_SIZE-COMMAND_SIZE+1))) {
				//num_packets = (size+1)/(MAX_PACKET_SIZE-COMMAND_SIZE); // data size fits exactly (+EOT)
			//} 
			//else {
				//num_packets = (size+1)/(MAX_PACKET_SIZE-COMMAND_SIZE)+1;
			//}
			//if (verbose)
				//printf("Splitting into '%i' packets.\r\n", num_packets);
			//
			//char num_char[2], *ptr_num_char;
			//num_char[0] = num_packets & 0xFF;
			//num_char[1] = (num_packets >> 8);
			//ptr_num_char = num_char;
				//
			//retval[0] = test_send_command_and_data(&dest_module->i2c_address, dest_port, src_port, ptr_num_char, PACKET_NUM_SIZE, CMD_SPLIT_START, priority);
			//retval[1] = test_split_packet(size, &dest_module->i2c_address, src_port, dest_port, data, num_packets, priority);
			//retval[2] = test_send_command(&dest_module->i2c_address, dest_port, src_port, CMD_SPLIT_STOP, priority);
		//}
		//else {
			//retval[0] = test_send_data(&dest_module->i2c_address, dest_port, src_port, data, size, priority);
		//}
		//break;
		//case COMMAND_PLUS_DATA:
		//// Check if packet has to be split
		//if (size > MAX_PACKET_SIZE) {
			//if (verbose) {
				//printf("Sending data: '%s'\r\n", data);
				//printf("This data has size '%i', which is too large to fit in one packet. Using splitting/recombining.\r\n", size);
			//}
			//
			//if (!(size % (MAX_PACKET_SIZE-COMMAND_SIZE+COMMAND_SIZE+1))) {
				//num_packets = (size+COMMAND_SIZE+1)/(MAX_PACKET_SIZE-COMMAND_SIZE); // data size + command bytes fits exactly (+EOT)
			//}
			//else {
				//num_packets = (size+COMMAND_SIZE+1)/(MAX_PACKET_SIZE-COMMAND_SIZE)+1;
			//}
			//if (verbose)
				//printf("Splitting into '%i' packets.\r\n", num_packets);
			//
			//char num_char[3];
			//num_char[0] = num_packets & 0xFF;
			//num_char[1] = (num_packets >> 8);
			//num_char[2] = ASCII_ENQ;
			//num_char[3] = command;
			//
			//retval[0] = test_send_command_and_data(&dest_module->i2c_address, dest_port, src_port, &num_char, PACKET_NUM_SIZE+COMMAND_SIZE, CMD_SPLIT_START, priority);
			//retval[1] = test_split_packet(size, &dest_module->i2c_address, src_port, dest_port, data, num_packets, priority);
			//retval[2] = test_send_command(&dest_module->i2c_address, dest_port, src_port, CMD_SPLIT_STOP, priority);
		//}
		//else {
			//retval[0] = test_send_command_and_data(&dest_module->i2c_address, dest_port, src_port, data, size, command, priority);
		//}
		//break;
	//}
	//// Return the status code
	//if (retval[1] == 1 && retval[2] == 1) {
		//return retval[0];
	//}
	//else {
		//for (int i=0; i<3; i++) {
			//if (retval[i] != 0) 
				//return retval[i]; // only one error returned if many
		//}
		//return STATUS_OK;
	//}
//}
//
//int test_split_packet(int size, uint8_t *i2c_addr, uint8_t *src, uint8_t *dest, char *data, int num_packets, csp_prio_t priority) {
	//char small_packet[MAX_PACKET_SIZE];
	//char *ptr_packet = small_packet;
	//int ret_val;
	//int sent_packets = 0;
	//
	//for (int i=0; i<num_packets; i++) {		
		//
		//// Last packet 
		//if (sent_packets == num_packets-1) {
			//int last_size = size-MAX_PACKET_SIZE*i;
			//
			//// Last data to be sent. Add EOT to end.
			//if (last_size > 0) {
				//memcpy(ptr_packet, data+i*MAX_PACKET_SIZE, last_size);
				//small_packet[last_size] = ASCII_EOT;
				//last_size++;
			//} 
			//// Only EOT byte to be sent. Data size must be at least 2, so packet becomes 4.
			//else if (last_size == 0) {
				//small_packet[0] = ASCII_EOT;
				//small_packet[1] = ASCII_EOT;
				//last_size += 2;
			//}		
			//
			//ret_val = test_send_command_and_data(i2c_addr, dest, src, ptr_packet, last_size, CMD_SPLIT, priority);
		//}
		//// Send the current portion of the data
		//else {
			//ret_val = test_send_command_and_data(i2c_addr, dest, src, data+i*MAX_PACKET_SIZE, MAX_PACKET_SIZE, CMD_SPLIT, priority);
		//}
		//sent_packets++;
		//
		//if (ret_val != STATUS_OK) {
			//break;
		//}
		//// Some delay to avoid congestion
		//vTaskDelay(SPLIT_SEND_DELAY);
	//}
	//return ret_val;
//}
//
//int test_send_data(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, char *data, uint8_t size, csp_prio_t priority) {
	//csp_packet_t *packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + size);
	//
	//// Copy the data to packet and send.	
	//if (packet != NULL) {
		//packet->length = size;
		//memcpy(packet->data, data, size);
		//
		//if (size == 0)
			//printf("Sending package with length 0. No connection will be made on receiving module!\r\n");
			//
		//if (test_send_packet(i2c_addr, dest_port, src_port, CSP_O_NONE, packet, priority) == ERR_IO_ERROR) {
			//printf("Data not sent.\r\n");
				//
			//return ERR_IO_ERROR;
		//}
		//else {
			//if (verbose) {
				//printf("Data '%.*s' sent | ", packet->length, packet->data);
				//printf("With length: %i\r\n", packet->length);			
			//}
			//packet = NULL;
				//
			//return STATUS_OK;
		//}
	//}
	//else {
		//return ERR_NO_MEMORY;
	//}
//}
//
//int test_send_command(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, command_t command, csp_prio_t priority) {
	//// Size is the packet struct itself plus 4 bytes (two extra due to small packets being rejected).
	//csp_packet_t *packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + COMMAND_SIZE + 2);
		//
	//if (packet != NULL) {
		//// Get command into packet data
		//if (command > 0 && command < MAX_COMMANDS) {
			//packet->length = 4;  // Packet has to be at least this size in order to be detected on receiver. Why?
			//packet->data[0] = ASCII_ENQ;
			//packet->data[1] = command;
		//}
		//else {
			//return ERR_BAD_DATA;
		//}
		//// Send packet.
		//if (test_send_packet(i2c_addr, dest_port, src_port, CSP_O_NONE, packet, priority) == ERR_IO_ERROR) {
			//printf("Command not sent.\r\n");
			//
			//return ERR_IO_ERROR;
		//}
		//else {
			//if (verbose)
				//printf("Sent command: %i\r\n", packet->data[1]);
			//packet = NULL;
			//
			//return STATUS_OK;
		//}
	//}
	//else {
		//return ERR_NO_MEMORY;
	//}
//}
//
//int test_send_command_and_data(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, char *data, uint8_t size, command_t command, csp_prio_t priority) {
	//csp_packet_t *packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + size + COMMAND_SIZE);
	//
	//if (packet != NULL) {
		//// Get command into packet data
		//if (command >= 0 && command < MAX_COMMANDS) {
			//packet->data[0] = ASCII_ENQ;
			//packet->data[1] = command;
		//}
		//else {
			//return ERR_BAD_DATA;
		//}
		//// Copy the data to be sent
		//packet->length = size + COMMAND_SIZE;
		//memcpy(&packet->data[2], data, size);
		//
		//// Send packet. Release buffer if fails
		//if (test_send_packet(i2c_addr, dest_port, src_port, CSP_O_NONE, packet, priority) == ERR_IO_ERROR) {			
			//csp_buffer_free(packet);
			//printf("Command+data not sent.\r\n");
				//
			//return ERR_IO_ERROR;
		//}
		//else {
			//if (verbose) {
				//printf("Sent command+data: command '%i' | ", packet->data[1]);
				//printf("data '%.*s' | ", size, &packet->data[2]);
				//printf("packet length '%i'\r\n", packet->length);
			//}
			//packet = NULL;
			//
			//return STATUS_OK;
		//}
	//}
	//return ERR_IO_ERROR;
//}
//
//int test_send_packet(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, uint8_t csp_flags, csp_packet_t *packet, csp_prio_t priority) {
	//// Send packet
	//printf("Prio: %i | I2C: %i | Dest: %i | Src: %i | Flags: %i ", priority, *i2c_addr, *dest_port, *src_port, csp_flags);
	//
	//printf("Packet_info: %i | I2C: %i | Dest: %i | Src: %i | Flags: %i ", priority, *i2c_addr, *dest_port, *src_port, csp_flags);
	//int err;
	//if ((err = csp_sendto(priority, *i2c_addr, *dest_port, *src_port, csp_flags, packet, CSP_SEND_TIMEOUT)) == ERR_IO_ERROR) {
		//csp_buffer_free(packet);
		//return ERR_IO_ERROR;
	//}
	//else {
		//if (verbose)
			//printf("Packet sent to %i:%i.\r\n", *i2c_addr, *dest_port);
		//packet = NULL;
		//return STATUS_OK;
	//}
//}
//
//void test_send_reply_command(csp_packet_t *packet, uint8_t command) {
	//// Size is the packet struct itself plus 4 bytes (two extra due to small packets being rejected).
	//csp_packet_t *ret_packet = test_csp_buffer_get_wrapper(sizeof(csp_packet_t) + COMMAND_SIZE + 2);
	//
	//if (ret_packet != NULL){
		//if (command > 0 && command < MAX_COMMANDS) {
			//packet->length = 4;  // Packet has to be at least this size in order to be detected on receiver. Why?
			//packet->data[0] = ASCII_ENQ;
			//packet->data[1] = command;
		//}
		//else {
			//printf("Error in command number.\r\n");
		//}
		//
		//if (csp_sendto_reply(packet, ret_packet, CSP_O_NONE, CSP_SEND_TIMEOUT) != CSP_ERR_NONE) {
			//csp_buffer_free(ret_packet);
			//csp_buffer_free(packet);
			//printf("Failed to send reply command\r\n");
		//}
		//else {
			//csp_buffer_free(packet);
			//packet = NULL;
			//ret_packet = NULL;
			//if (verbose)
				//printf("Sent reply command: %i\r\n", command);
		//}
	//}
//}
//
//uint8_t * test_get_first_second_port(modules_t *module, first_second_port_t port_num, src_dest_t src_dest) {
	//uint8_t *ret;
	//
	//// Finding pointer to the first or second listner/source port
	//switch (src_dest) {
		//case SRC:
		//if (port_num == FIRST_SRC_DEST) {
			//ret = &module->source_port;
		//} 
		//else if (port_num == SECOND_SRC_DEST) {
			//ret = &module->source_port_2;
		//}
		//break;
		//case DEST:
		//if (port_num == FIRST_SRC_DEST) {
			//ret = &module->listen_port;
		//}
		//else if (port_num == SECOND_SRC_DEST) {
			//ret = &module->listen_port_2;
		//}
		//break;
	//}
	//return ret;
//}
//
//csp_socket_t * test_create_listen_socket(uint8_t port) {
	////create the socket
	//csp_socket_t *listen_socket = csp_socket(CSP_SO_NONE);
	//if (listen_socket == NULL)
		//return NULL;
	//
	////Bind socket to port
	//if (csp_bind(listen_socket, port) != CSP_ERR_NONE)
		//return NULL;
	//
	////Activate listening for socket
	//if (csp_listen(listen_socket, BACKLOG_CON_QUEUE) != CSP_ERR_NONE)
		//return NULL;
		//
	//return listen_socket;
//}
//
//void * test_csp_buffer_get_wrapper(size_t size){
	//csp_packet_t *packet = csp_buffer_get(size);
	//packet->id.ext = 0;
	//packet->length = 0;
	//for(int i = 0; i < CSP_PADDING_BYTES; i++){
		//packet->padding[i] = '\0';
	//}
	//return packet;
//}
//
//void test_toggle_verbosity(void) {
	//verbose = !verbose;
	//if (verbose)
		//printf("Verbosity: ON\r\n");
	//else
		//printf("Verbosity: OFF\r\n");
//}
//
//void test_print_csp_memory(void) {
	//printf("Buffer size: %i | Buffer remaining: %i\r\n", csp_buffer_size(), csp_buffer_remaining());
//}
//
//
//void delete_default_listening_task(void){
	//vTaskDelete(xListenTask);
//}
//
///************************************************************************/
///*							UTIL										*/
///************************************************************************/
//
//int load_stress_pattern_into_char(bit_pattern_t bit_pat){ 
	//switch (bit_pat) {
		//case BIT_PAT_1_IN_7:
		//bit_pattern_1_in_7();
		//return 100;
		//case BIT_PAT_3_IN_24:
		//bit_pattern_3_in_24();
		//return 100;
		//case BIT_PAT_ALL_ONES:
		//bit_pattern_all_ones();
		//return 100;
		//case BIT_PAT_ALL_ZEROS:
		//bit_pattern_all_zeros();
		//return 100;
		//case BIT_PAT_ALT:
		//bit_pattern_alternating();
		//return 100;
		//case BIT_PAT_QRSS:
		//bit_pattern_QRSS();
		//return 188;
		//default:
		//return 0;
	//}
//}
//
//
//
//int simple_compare(char * original, char * comp, int length){
	//for (int i = 0; i < length; i++){
		//if (original[i] != comp[i]) {
			//printf("Differs in byte '%i' with original '%d', comp '%d'\r\n",i,original[i],comp[i]);
			//return 0;
		//}
	//}
	//return 1;
//}
//
//bool starts_with(char * str, char * start){
	//return simple_compare(str, start, strlen(start));
//}
//
//int str2int(const char* str, int len){
	//int tmp = 0;
	//for(int i = 0; i < len; ++i){
		//// Subtract the character zero from the ascii character to obtain int
		//tmp = tmp * 10 + (str[i] - '0');
	//}
	//return tmp;
//}
