///*
 //* csp_testing.h
 //*
 //* Created: 19.02.2014 11:53:30
 //* Author: EIT ROMTEKNOLOGI GR.5 2014
 //*/
//
//#ifndef CSP_TESTING_H_
//#define CSP_TESTING_H_
//#include "projdefs.h"
//#include "conf_csp.h"
//#include "portmacro.h"
//#include "csplib/csp_util.h"
//#include "csplib/include/csp/csp.h"
//#include "bit_patterns.h"
//
///************************************************************************/
///*                      DEFINES                                         */
///************************************************************************/
//
///*Module definitions*/
//#define ONBOARD_COMPUTER		0
//#define RADIO					1
//#define OTHER_MODULE			2
//
////#########################################################
//// THE DEFINITION OF WHICH CUBESAT MODULE THIS IS!!!
//// Defines the module. Either OBC=0, RADIO=1 or OTHER=2 
//// (the same as in cubesat_module enum)
//#define MODULE		RADIO
////#########################################################
//
//// I2C addresses used for testing
//#define OBC_I2C_ADDR	0x02
//#define RADIO_I2C_ADDR	0x04
//#define OTHER_I2C_ADDR	0x06
//
//// CSP addresses used for testing
//#define OBC_CSP_ADDR	0x02
//#define RADIO_CSP_ADDR	0x04 
//#define OTHER_CSP_ADDR	0x06
//
//// Source ports used for testing
//#define OBC_SRC_PORT		0x10
//#define OBC_SRC_PORT_2		0x19
//#define RADIO_SRC_PORT		0x11
//#define RADIO_SRC_PORT_2	0x20
//#define OTHER_SRC_PORT		0x12
//#define OTHER_SRC_PORT_2	0x21
//
//// Destination/listener ports used for testing
//#define OBC_LISTEN_PORT		0x10
//#define OBC_LISTEN_PORT_2   0x14
//#define RADIO_LISTEN_PORT	0x11
//#define RADIO_LISTEN_PORT_2	0x16
//#define OTHER_LISTEN_PORT	0x12
//#define OTHER_LISTEN_PORT_2	0x18
//
//// CSP timeout constants
//#define CSP_SEND_TIMEOUT	1000
//#define CSP_ACCEPT_TIMEOUT	20000
//#define CSP_READ_TIMEOUT	0
//
//// Command settings
//#define ASCII_ENQ			0x05	// Used to indicate command packet
//#define ASCII_EOT			0x04	// Sent after last byte of split packet
//#define MAX_COMMANDS		256		// Maximum number of commands
//#define COMMAND_SIZE		2		// Size of command in packet
//
//// Div
//#define FIRST_LISTEN_TASK	0
//#define SECOND_LISTEN_TASK	1
//#define MANY_PACKETS_NUM	500
//
//// Split packet
//#define MAX_PACKET_SPLIT_SIZE	20*MAX_PACKET_SIZE		// Maximum number of packets to split/combine
//#define MAX_PACKET_SIZE			60						// Size of data to send in each packet. max 61
//#define PACKET_NUM_SIZE			2						// Bytes that define number of split packets
//#define PACKET_NUM_CMD_SIZE		PACKET_NUM_SIZE+COMMAND_SIZE  // Size of packet number and command bytes
//
//// Delay values
//#define SPLIT_SEND_DELAY			100		// Time to wait before sending next part of split packet
//#define SEND_MANY_PACKETS_DELAY		100		// Interval between sending of packets in "send many packets"-test
//
//// Stress test bit pattern settings
//#define CHUNK_SIZE 5 
//#define NUM_STRESS_PATTERNS_SENDING 50
//#define NUM_TYPES_STRESS_PATTERNS	6
//
///************************************************************************/
///*                      TYPEDEFS                                        */
///************************************************************************/
//
////! Used to declare new tests in the pool of available tests.
//typedef struct {
	//char * actionName;
	//void (*actionPtr)(void);
//} test_action;
//
//typedef struct {
	//char * actionName;
	//int needs_packet;
	//void (*actionPtr)(void*);
//} test_listener_action;
//
//typedef enum {
	//TO_SLAVE = 1,
	//TO_MASTER = 0
//} transfer_direction;
//
//typedef struct {
	//uint8_t csp_address;
	//uint8_t listen_port;
	//uint8_t listen_port_2;
	//uint8_t source_port;
	//uint8_t source_port_2;
	//uint8_t i2c_address;
//}  modules_t;
//
//typedef enum {
	//FIRST_SRC_DEST = 0,
	//SECOND_SRC_DEST = 1
//} first_second_port_t;
//
//typedef enum {
	//SRC = 0,
	//DEST = 1
//} src_dest_t;
//
//
//typedef enum {
	//COMMAND = 0,
	//DATA = 1,
	//COMMAND_PLUS_DATA = 2
//} packet_type_t;
//
//typedef enum {
	//CMD_DEFAULT		= 0,
	//CMD_SEND_BACK	= 1,
	//CMD_BOUNCE		= 2,
	//CMD_RETURN		= 3,
	//CMD_RETURNED	= 4,
	//CMD_SPLIT_START = 5,
	//CMD_SPLIT_STOP  = 6,
	//CMD_CIRCLE		= 7,
	//CMD_SPLIT		= 8,
	//CMD_PING_REPLY	= 9,
	//CMD_PATTERN		= 10,
	//NO_COMMAND		= 98,
	//CMD_DO_NOTHING	= 99
//} command_t;
//
//typedef enum {
	//BIT_PAT_1_IN_7 = 0,
	//BIT_PAT_ALL_ONES,
	//BIT_PAT_ALL_ZEROS,
	//BIT_PAT_3_IN_24,
	//BIT_PAT_QRSS,
	//BIT_PAT_ALT
//} bit_pattern_t;
//
///************************************************************************/
///*						COMMON/SETUP									*/
///************************************************************************/
//
///**
 //* Simplifies testing with few serial communication resources
 //*/
//void csp_test_init(void);
//
///**
 //* Function that creates and initiates the needed I2C and CSP setups.
 //* Should only be executed once.
 //* \param void
 //* \return void
 //*/
//void test_default_setup(void);
//
///**
 //* Prints the available tests to the console.
 //* \param void
 //* \return void
 //*/
//void test_print_available_tests(void);
//
///**
 //* Printing number of packets received to the CLI
 //* \param void
 //* \return void
 //*/
//void print_packets_received(void);
//
///**
 //* Function to run a test. Will start the test
 //* with the correct number. The started test will run in a separate task. 
 //* \param test_nr	The number of the test to run.
 //* \return			void
 //*/
//void test_start_test_task(portCHAR * test_nr_str);
//
///************************************************************************/
///*						TEST LISTENER                                   */
///************************************************************************/
//
///**
 //* The listener. Listens for incoming packets on this module's first listen port.
 //* If a packet is received it checks for command, and runs the listening 
 //* action associated with the command (if command is detected). If no 
 //* command, the default listener action is called. If needs_packet is specified 
 //* as true in the listener action array , pointer to the incoming packet is passed to
 //* the action function that is run.
 //* \param ptr	FreeRTOS task creation pointer
 //* \return		void
 //*/
//void test_listen_all_task(void *ptr);
//
///**
 //* The default listener action. Prints the received packet data to console.
 //* \param ptr	Pointer to the packet, passed via task creation ptr.
 //* \return		void
 //*/
//void test_listener_default(void *ptr);
//
///**
 //* Return the received packet to sender.
 //* \param ptr	Pointer to the packet, passed via task creation ptr.
 //* \return		void
 //*/
//void test_listener_return_packet(void *ptr);
//
///**
 //* Send a packet acknowledging the received packet to source module
 //* (somewhat like ping).
 //* \param void
 //* \return void
//*/
//void test_send_return_message(void *ptr);
//
///**
 //* Run if returned command is received from other module. 
 //* Increases the appropriate received packet counters.
 //* \param void
 //* \return void
//*/
//void test_message_got_returned(void *ptr);
//
///**
 //* Start of splitted packet. The packets following will be added
 //* to a receiving buffer, to be combined to the original message.
 //* \param void
 //* \return void
//*/
//void test_recieve_split_packet(void *ptr);
//
///**
 //* Reply to a ping request of high priority
 //* \param ptr The packet received
 //* \return void
//*/
//void test_high_priority_ping_reply(void *ptr);
//
///**
 //* Check incoming packet and send command to next module in circle.
 //* \param ptr The packet received
 //* \return void
//*/
//void test_listener_circle_between_three_modules(void *ptr);
//
///**
 //* Check incoming stress bit pattern against reference pattern.
 //* \param ptr The packet size
 //* \return void
//*/
//void test_check_stress_pattern(void *ptr);
//
///************************************************************************/
///*						TESTS											*/
///************************************************************************/
//
///**
 //* Send many command packets to the other module. The command is defined to
 //* not do anything on the receiving module. 
 //* \param void
 //* \return void
 //*/
//void test_send_many_packets(void);
//
///**
 //* Send big packet to the other module
 //* \param void
 //* \return void
 //*/
//void test_send_big_packet(void);
//
///**
 //* Send big packet to the other module
 //* \param void
 //* \return void
 //*/
//void test_send_RDP(void);
//
///**
 //* Send a very big packet to the other module, that has to be split/recombined.
 //* \param void
 //* \return void
 //*/
//void test_send_huge_packet(void);
//
///**
 //* Send big packet to other module. This packet is then returned to the initiator.
 //* \param void
 //* \return void
 //*/
//void test_send_big_packet_back(void);
//
///**
 //* Start second listener. The listening port is defined as listen_port_2 for this module.
 //* \param void
 //* \return void
 //*/
//void test_setup_multiple_listeners(void);
//
///**
 //* Start sending packets to the two other modules simultaneously.
 //* \param void
 //* \return void
 //*/
//void test_run_multiple_senders(void);
//
///**
 //* Send command back to the source module. Uses CSP reply, 
 //* so the same connection is used.
 //* \param packet   The incoming packet which source will be used as destination.
 //* \param command  Command to be sent.
 //* \return void
//*/
//void test_send_reply_command(csp_packet_t *packet, uint8_t command);
//
///**
 //* Test for sending a bit-pattern that is stored in the file "stress-pattern.txt"
 //* \param void
 //* \return void
 //*/
//void test_send_stress_pattern(void);
//
///**
 //* Send a defined packet in circle between three modules. Packet content is checked against
 //* the reference when received. 
 //* \param ptr		Pointer to packet. NULL when test is initiated.
 //* \return void
 //*/
//void test_circle_between_three_modules(void);
//
///**
 //* Bounce command packets between two modules. The initiatior sends a command to the
 //* other module making it send the same command back. And this continues 
 //* indefinitely. 
 //* \param void
 //* \return void
 //*/
//void test_packet_bounce_between_two_modules(void);
//
///**
 //* Initiates a task that sends a ping request to the OBC (bounce back command). 
 //* \param void
 //* \return void
 //*/
//void test_high_priority_ping_obc(void);
//
///**
 //* Starts the three-module test where this module is B.
 //* The A module spams the B module (this module)
 //* The C module sends ping-requests once every second with critical priority to the B module.
 //* The output of this test is read off the C-module, which prints the successful replies.
 //* \param void
 //* \return void
 //*/
//void test_spammer_obc(void);
//
///**
 //* Sends a spamming signal to the target module, B.  Made as a second step in the priority test
 //* \param void
 //* \return void
 //*/
//void test_three_module_spam_and_critical_spammer(void); 
///************************************************************************/
///*						TESTS HELPER FUNCTIONS 							*/
///************************************************************************/
//
///**
 //* Send packet back to the source module.
 //* \param data	The data to be sent
 //* \return void
 //*/
//void test_send_packet_back(char *data);
//
//
///************************************************************************/
///*						        HELPER FUNCTIONS						*/
///************************************************************************/
//
///**
 //* Allocates the specified packet size (NB: Including sizeof(csp_packet_t)).
 //* The packet is then cleaned by initializing certain members, and inserting padding.
 //* \return				void*
 //*/
//void * test_csp_buffer_get_wrapper(size_t size);
//
///**
 //* The main send function. Can be used for both command or data. Splits
 //* large data to smaller packets before sending. Possible to use first or
 //* second port of modules.
 //* \param type			Packet type
 //* \param dest_module	Destination module
 //* \param src_module	Source module
 //* \param port_num		First or second port
 //* \param data			Pointer to the data to be sent
 //* \param size			Data length
 //* \param size			Command to be sent
 //* \param priority		The CSP priority
 //* \return				void
 //*/
//int test_send(packet_type_t type, modules_t *dest_module, modules_t *from_module, first_second_port_t port_num, char *data, int size, command_t command, csp_prio_t priority);
//
///**
 //* Send data over CSP to specified destination module. 
 //* \param i2c_addr		Pointer to I2C address of destination module
 //* \param dest_port		Pointer to the destination port
 //* \param src_port		Pointer to the source port
 //* \param data			Pointer to the data to be sent
 //* \param size			Data length
 //* \param priority		The CSP priority
 //* \return				STATUS_OK if sent, ERR_IO_ERROR if fails sending,
 //*						ERR_NO_MEMORY if out of memory
 //*/
//int test_send_data(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, char *data, uint8_t size, csp_prio_t priority);
//
///**
 //* Send command over CSP to specified destination module. 
 //* \param i2c_addr		Pointer to I2C address of destination module
 //* \param dest_port		Pointer to the destination port
 //* \param src_port		Pointer to the source port
 //* \param command		Command to be sent
 //* \param priority		The CSP priority
 //* \return				STATUS_OK if sent, ERR_IO_ERROR if fails sending,
 //*						ERR_NO_MEMORY if out of memory
 //*/
//int test_send_command(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, command_t command, csp_prio_t priority);
//
///**
 //* Send the provided packet to destination
 //* \param i2c_addr		Pointer to I2C address of destination module
 //* \param dest_port		Pointer to the destination port
 //* \param src_port		Pointer to the source port
 //* \param csp_flags		Pointer to csp connection flags. NB: No checks of these values are performed by CSP!
 //* \param packet		Pointer to the packet to send
 //* \param priority		The CSP priority
 //* \return				STATUS_OK if sent, ERR_IO_ERROR if fails sending.
 //*/
//int test_send_packet(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, uint8_t csp_flags, csp_packet_t *packet, csp_prio_t priority);
//
///**
 //* Send packet containing command and data over CSP to specified destination module. 
 //* \param dest_module	The destination module
 //* \param from_module	THe source module
 //* \param command		The command to be sent. Maps to listener action array.
 //* \param data			The data
 //* \param data			Data size
 //* \param priority		The CSP priority
 //* \param port_num		Use first or second listen/source port. 
 //* \return				STATUS_OK if sent, ERR_IO_ERROR if fails
 //*/			
//int test_send_command_and_data(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, char *data, uint8_t size, command_t command, csp_prio_t priority);
//
///**
 //* Splits large packets to many packets with maximum size. Keeps track of the order. Then
 //* send to destination.
 //* \param size		Data size
 //* \param i2c_addr	The I2C address of receiver
 //* \param src		Source port
 //* \param dest		Destination port
 //* \param data		The data to be sent
 //* \return void
 //*/
//int test_split_packet(int size, uint8_t *i2c_addr, uint8_t *src, uint8_t *dest, char *data, int num_packets, csp_prio_t priority);
//
///**
 //* Toggle if there should be output a high amount of debug text to the console.
 //* \param void
 //* \return void
 //*/
//void test_toggle_verbosity(void);
//
///**
 //* Prints information about CSP memory usage to console
 //* \param void
 //* \return void
 //*/
//void test_print_csp_memory(void);
//
///**
 //* Create a listening socket on the specified port.
 //* \param port	The port to use
 //* \return		Pointer to the created csp_socket_t 
 //*/
//csp_socket_t * test_create_listen_socket(uint8_t port);
//
///**
 //* Returns first or second port of the specified module. Port can be for
 //* listening or as source.
 //* \param module    The module
 //* \param port_num  Specify if getting first or second port
 //* \param src_dest  Return source or destination port
 //* \return			Pointer to the port
 //*/
//uint8_t * test_get_first_second_port(modules_t *module, first_second_port_t port_num, src_dest_t src_dest);
//
///************************************************************************/
///*						        UTIL                                    */
///************************************************************************/
//
///**
 //* This function loads the specified bit pattern into the bit pattern array.
 //* \param bit_pat The wanted bit pattern
 //* \return Size of bit pattern
 //
 //*/
//int load_stress_pattern_into_char(bit_pattern_t bit_pat);
///**
 //* This function compares the data of two char arrays for a fixed length.
 //* This was implemented since string compare had some issues being dependent
 //* on '\0' at the end of the array.
 //* \param original  Pointer to one of the arrays to compare
 //* \param comp		Pointer to one of the arrays to compare
 //* \length			Length of the array to compare
 //* \return			1 for equal, 0 if not.
 //*/
//int simple_compare(char *original, char *comp, int length);
//
///**
 //* Compares two strings to see if str starts with the characters specified in start (case sensitive).
 //* \param str	The string to check.
 //* \param start The starting characters.
 //* \return		True if match, else false.
 //*/
//bool starts_with(char * str, char * start);
//
///**
 //* Default behavior for the listener (currently listens for big/small packet)
 //* \param str The string to convert to numeric
 //* \param len The length of the string (not including null terminator).
 //* \return	  The int value
 //*/
//int str2int(const char* str, int len);
//
//
//// TEMP FUNCTIONS
//
//void test_send_big_packet_second_port(void);
//
///**
 //* Delete the task responsible for displaying number of received packets
 //* Used when leaving the CSP "directory"
 //*/
//void delete_default_listening_task(void);
//
//
//
//
//
//#endif /* CSP_TESTING_H_ */
