/*
 * nrp_csp_if.c
 *
 * Created: 20-Feb-15 2:10:23 PM
 *  Author: Erlend
 */ 

#include "csplib/include/csp/csp.h"
#include "csplib/csp_util.h"
#include "csplib/include/csp/csp_buffer.h"
#include "csplib/NRP/nrp.h"
#include "csplib/NRP/nrp_debug.h"
#include "csplib/NRP/nrp_error.h"

static xTaskHandle xCSPListenPort;



csp_socket_t * create_listen_socket(uint8_t port, uint32_t socket_opt) {
	//create the socket
	csp_socket_t *listen_socket = csp_socket(socket_opt);
	int status;
	if (listen_socket == NULL){
		NRP_PRINT_ERROR("Error creating socket");
		return NULL;
	}


	//Bind socket to port
	if ((status = csp_bind(listen_socket, port)) != CSP_ERR_NONE){
		NRP_PRINT_ERROR("Error binding socket");
		return NULL;
	}

	//Activate listening for socket
	if ((status = csp_listen(listen_socket, BACKLOG_CON_QUEUE)) != CSP_ERR_NONE){
		NRP_PRINT_ERROR("Error listening to socket");
		return NULL;
	}

	return listen_socket;
}


int8_t csp_create_listener(uint8_t listen_port, void (*listener_ptr)(void *arg_ptr)){
	int status = SUCCESS;
	xCSPListenPort = NULL;
	
	status = xTaskCreate(listener_ptr, "NRP", configTSK_LISTENTASK_STACK_SIZE, (void*)&listen_port, tskIDLE_PRIORITY, xCSPListenPort);
	if (status != pdPASS){
		NRP_PRINT_ERROR_CODE(UNABLE_TO_CREATE_LISTENER);
		return UNABLE_TO_CREATE_LISTENER;
	}
	return status;
}

