/*
 * nrp_error.c
 *
 * Created: 22-Mar-15 9:11:20 PM
 *  Author: Erlend
 */ 

#include "csplib/NRP/nrp_error.h"
#include <stdlib.h>


/* Returns a pointer to an error message defined by def_error*/
void nrp_get_error_message(char *buf, int8_t defined_error){
	//Return empty string if NRP_DEBUG is off because it isnt needed
	#if NRP_DEBUG <= NRP_DEBUG_OFF
		buf = "\0";
	
	#else
		switch (defined_error){
			case SUCCESS:
			char *text = "No error, returned SUCCESS";
			sprintf(buf, text, strlen(text));
			break;
			
			case UNABLE_TO_CREATE_LISTENER:
			buf = "Unable to create CSP listener";
			break;
			
			case SEND_FAILED: 
			buf = "Sending packet failed";
			break;
			
			case ADDRESS_OUT_OF_RANGE: 
			buf = "Address was out of range, use addresses in range 1 - 31";
			break;
			
			case ILLEGAL_PORT_NUMBER: 
			buf = "Illegal port number, use ports 5-14 when sending, and 15-24 for receiving";
			break;
			
			case UNABLE_TO_INITIALIZE_CSP:
			buf = "Unable to initialize CSP";
			break;
			
			case UNABLE_TO_CREATE_TASK:
			buf = "Unable to create task";
			break;
			
			case NO_SUCH_MODULE:
			buf = "Requested module is not in module-list";
			break;
			
			case CONN_POOL_FULL:
			buf = "The connection pool is full and is not able to take more connections";
			break;
			
			case PORT_ALREADY_CONNNECTED:
			buf = "A request for a connection was made from a port that was already connected";
			break;
			
			case QUEUE_FULL:
			buf = "The ACK-wait-queue is full and cannot take more packets";
			break;
			
			case UNABLE_TO_CREATE_MUTEX:
			buf = "Unable to create mutex";
			break;
			
			case UNABLE_TO_OBTAIN_MUTEX:
			buf = "Waiting for mutex timed out. IMPORTANT: possible deadlock in program!";
			break;
			
			case CSP_PACKET_BUFFER_FULL:
			buf = "CSP packet buffer is full, packets are not freed correctly from buffer";
			break;
			
			case: PORT_NOT_BOUND:
			buf = "\r\nNo task is listening to the requested port";
			break;
			
			
			case CONN_ID_NOT_FOUND:
			buf = "Requested connection ID not found";
			break;
			
			default:
			sprintf(buf, "The error code '%i' is not defined in nrp_error", def_error);
			break;
		}
	#endif
}