/*
 * nrp_error.h
 *
 * Created: 22-Mar-15 9:08:23 PM
 *  Author: Erlend
 */ 


#ifndef NRP_ERROR_H_
#define NRP_ERROR_H_

#include <stdint.h>

//Errors
#define SUCCESS							 0
#define SEND_FAILED						-1
#define MALLOC_FAILED					-2
#define UNABLE_TO_CREATE_LISTENER		-3
#define ADDRESS_OUT_OF_RANGE			-4
#define ILLEGAL_PORT_NUMBER				-5
#define UNABLE_TO_INITIALIZE_CSP		-6
#define UNABLE_TO_CREATE_TASK			-7
#define NO_SUCH_MODULE					-8
#define CONN_POOL_FULL					-9
#define PORT_ALREADY_CONNNECTED		   -10
#define QUEUE_FULL					   -11
#define UNABLE_TO_CREATE_MUTEX		   -12
#define UNABLE_TO_OBTAIN_MUTEX		   -13
#define CSP_PACKET_BUFFER_FULL		   -14
#define UNABLE_TO_CREATE_PORT_HANDLER  -15
#define PORT_ALREADY_BOUND			   -16
#define CONN_ID_NOT_FOUND			   -17
#define PORT_NOT_BOUND				   -18  //no task is listening to the requested port
#define PAYLOAD_ERROR				   -19




/**
 * The function returns a pointer to a string with an 
 * appropriate error message according to the error 
 * defined by the parameter def_error
 *
 *	@param def_error:  a defined negative number specifying the error
 *
 *	@return Pointer to a string containing an error message
 */
void nrp_get_error_message(char *buf, int8_t defined_error);



#endif /* NRP_ERROR_H_ */