/*
 * ncsp_segmenter.c
 *
 * Created: 14-Feb-15 3:51:20 PM
 *  Author: Erlend
 */ 

#include "serial.h"
#include "csplib/NRP/nrp.h"
#include "csplib/NRP/nrp_header.h"
#include "csplib/include/csp/csp.h"
#include "conf_csp.h"

void nrp_use_segmentation(uint8_t stream[][CSP_MAX_DATA_SIZE], uint8_t *payload, uint32_t payload_length, uint8_t csp_header[CSP_HEADER_LENGTH]){
	
	uint8_t packets_in_stream = payload_length % NRP_MAX_PAYLOAD_SIZE == 0 ? 
		payload_length / NRP_MAX_PAYLOAD_SIZE : 
		(payload_length / NRP_MAX_PAYLOAD_SIZE) + 1;
	
	//Generate sequence numbers
	uint32_t seq = payload_length;
	
	Bool last_packet_in_stream = false;
	Bool first_packet_in_stream = true;
	uint8_t last_packet_size = 0;
	
	//divide payload into smaller chunks and put the chunks into individual arrays
	uint8_t payload_copy[NRP_MAX_PAYLOAD_SIZE];
	for (int packets = 0; packets < packets_in_stream; packets++){
		for (int bytes = 0; bytes < NRP_MAX_PAYLOAD_SIZE; bytes++){
			payload_copy[bytes] = *(payload++);
			
			//Check if all bytes are placed in an array
			if ((packets * (NRP_MAX_PAYLOAD_SIZE) + (bytes + 1)) >= payload_length) {
				last_packet_in_stream = true;
				last_packet_size = bytes + 1;
				break; //
			}
		}
		
		// add nrp headers to the splitted payload packets
		nrp_make_reliable_packet(&stream[packets][0], first_packet_in_stream ? NRP_SYN : NRP_ARQ, seq, payload_copy,
									 last_packet_in_stream ? last_packet_size : NRP_MAX_PAYLOAD_SIZE, 
									 csp_header);
									 
		if (first_packet_in_stream) first_packet_in_stream = false;
		
		//update sequence number to set in next packet
		seq -= NRP_MAX_PAYLOAD_SIZE;
	}
}

