/*
 * ncsp_segment.h
 *
 * Created: 16-Feb-15 4:40:25 PM
 *  Author: Erlend Riis Jahren, NUTS
 */ 


#ifndef NCSP_SEGMENT_H_
#define NCSP_SEGMENT_H_


/**
 * Function splits a large array into smaller arrays of size NRP_MAX_PAYLOAD, and generates NRP headers for
 * each packet, with sequence-numbers and flags/etc.
 *
 * @param **stream:				A "two dimensional" array for storing all packets of the stream.
 * @param *payload:				The full payload of the stream
 * @param payload_length:		the length  of the payload, max 2^24
 * @param csp_header:			a dummy CSP header to generate CRC-16 
 *
 * @return:					void
 */
void nrp_use_segmentation(uint8_t **stream, uint8_t *payload, uint32_t payload_length, uint8_t csp_header[CSP_HEADER_LENGTH]);


#endif /* NCSP_SEGMENTER_H_ */