///*
 //* csp_controller.h
 //*
 //* Created: 10-Nov-14 4:28:24 PM
 //*  Author: Erlend
 //*/ 
//
//
//#ifndef CSP_CONTROLLER_H_
//#define CSP_CONTROLLER_H_
//
//#include "projdefs.h"
//#include "conf_csp.h"
//#include "portmacro.h"
//#include "csplib/csp_util.h"
//#include "csplib/include/csp/csp.h"
////#include "bit_patterns.h"
//
///************************************************************************/
///*                      DEFINES                                         */
///************************************************************************/
//
///*Module definitions*/
//#define ONBOARD_COMPUTER		0
//#define RADIO					1
//#define CAMERA					2
//
////#########################################################
//// THE DEFINITION OF WHICH CUBESAT MODULE THIS IS!!!
////#define MODULE		OBC
////#########################################################
//
//// I2C addresses
//#define OBC_I2C_ADDR		0x02
//#define RADIO_I2C_ADDR		0x04
//#define CAMERA_I2C_ADDR		0x06
//
//// CSP addresses
//#define OBC_CSP_ADDR		  OBC_I2C_ADDR
//#define RADIO_CSP_ADDR		RADIO_I2C_ADDR
//#define CAMERA_CSP_ADDR	   CAMERA_I2C_ADDR
//
//// Destination/listener port examples MAX 6bit
//#define OBC_DEFAULT_LISTEN_PORT		0x10
//#define RADIO_DEFAULT_LISTEN_PORT	0x11
//#define CAMERA_DEFAULT_LISTEN_PORT	0x12
//
//#define OBC_LOOP_TEST_LISTEN_PORT		0x17
//#define RADIO_LOOP_TEST_LISTEN_PORT		0x18
//#define CAMERA_LOOP_TEST_LISTEN_PORT	0x19
//
//// Other port examples that can be changed as desired
//#define OBC_FILE_SYSTEM_LISTEN_PORT		0x13
//#define OBC_DETUMBLE_LISTEN_PORT		0x14
//#define RADIO_TO_GROUND_LISTEN_PORT		0x15
//#define CAMERA_COMMAND_LISTEN_PORT		0x16
//
////CSP specifics
//#define MAX_ADDR		31
//#define MAX_PORT		63
//
//// CSP timeout constants
//#define CSP_SEND_TIMEOUT		   1000
//#define CSP_ACCEPT_TIMEOUT	 0xffffffff //Maximum (32 bit)
//#define CSP_READ_TIMEOUT			100  
//#define CSP_NO_TIMEOUT				  0
//
//// Command settings
//#define ASCII_ENQ			0x05	// Used to indicate command packet
//#define ASCII_EOT			0x04	// Sent after last byte of split packet
//#define MAX_COMMANDS		256		// Maximum number of commands
//#define COMMAND_SIZE		2		// Size of command in packet
//
//// Split packet
////#define MAX_PACKET_SIZE			60						// Size of data to send in each packet. max 61
//#define MAX_PACKET_SPLIT_SIZE	20*MAX_PACKET_SIZE		// Maximum number of packets to split/combine
//#define PACKET_NUM_SIZE			2						// Bytes that define number of split packets
//#define PACKET_NUM_CMD_SIZE		PACKET_NUM_SIZE+COMMAND_SIZE  // Size of packet number and command bytes
//
//// Delay values
//#define SPLIT_SEND_DELAY			100		// Time to wait before sending next part of split packet
//#define SEND_MANY_PACKETS_DELAY		100		// Interval between sending of packets in "send many packets"-test
//
////Errors - add more
//#define SUCCESS							 0
//#define ADDRESS_OUT_OF_RANGE			-4
//#define PORT_NUMBER_OUT_OF_RANGE		-5
//#define UNABLE_TO_INITIALIZE_CSP		-6
//#define UNABLE_TO_CREATE_LISTENER		-7
//#define NO_SUCH_MODULE					-8
//
///************************************************************************/
///*                      TYPEDEFS                                        */
///************************************************************************/
//typedef enum {
	//TO_SLAVE = 1,
	//TO_MASTER = 0
//} transfer_direction;
//
////typedef struct {
	////uint8_t module_number;
	////uint8_t csp_address;
	////uint8_t i2c_address;
	////uint8_t default_listen_port;
	////char name[10];
////}  nuts_module_t;
////
////typedef struct {
	////nuts_module_t module;
	////uint8_t port;
////}  module_socket_t;
//
//typedef enum {
	//SRC = 0,
	//DEST = 1
//} src_dest_t;
//
//typedef enum {
	//COMMAND = 0,
	//DATA = 1,
	//COMMAND_PLUS_DATA = 2
//} packet_type_t;
//
//typedef enum {
	//CMD_DEFAULT		= 0,
	//CMD_SEND_BACK	= 1,
	//CMD_BOUNCE		= 2,
	//CMD_RETURN		= 3,
	//CMD_RETURNED	= 4,
	//CMD_SPLIT_START = 5,
	//CMD_SPLIT_STOP  = 6,
	//CMD_CIRCLE		= 7,
	//CMD_SPLIT		= 8,
	//CMD_PING_REPLY	= 9,
	//CMD_PATTERN		= 10,
	//NO_COMMAND		= 98,
	//CMD_DO_NOTHING	= 99
//} command_t;
//
//
//typedef enum {
	//BIT_PAT_1_IN_7 = 0,
	//BIT_PAT_ALL_ONES,
	//BIT_PAT_ALL_ZEROS,
	//BIT_PAT_3_IN_24,
	//BIT_PAT_QRSS,
	//BIT_PAT_ALT
//} bit_pattern_t;
//
//
///*Examples of modules, add and remove as wanted*/
//static const nuts_module_t nuts_modules [] = {
	//{OBC,		OBC_CSP_ADDR,		OBC_I2C_ADDR,		OBC_DEFAULT_LISTEN_PORT,		"OBC"},
	//{RADIO,		RADIO_CSP_ADDR,		RADIO_I2C_ADDR,		RADIO_DEFAULT_LISTEN_PORT,		"RADIO"},
	//{CAMERA,	CAMERA_CSP_ADDR,	CAMERA_I2C_ADDR,	CAMERA_DEFAULT_LISTEN_PORT,		"CAMERA"}
//};
//
//
//cubesat_module this_module;
//
//
///************************************************************************/
///* Methods                                                              */
///************************************************************************/
//
///* Initializes CSP for a given address. Cannot be changed when initialized.
 //* 
 //* \param: the defined module number
 //* \return: 0 on success, negative numbers on error
 //*/
//int8_t csp_default_setup(uint8_t module_number);
//
///* Populates a nuts_module_t struct from the defined module structs in the
 //* nuts_modules list
 //*
 //*\param:	csp_address: address of the module you want to copy 
 //*			*module_ptr: the module you want to populate
 //*\return	0 on success, negative on error
 //
 //\NOTE: Unneccesary, as module = nuts_modules[OBC/RADIO/CAMERA]; will work to..
 //*/
//int8_t get_nuts_module(uint8_t csp_address, nuts_module_t *module_ptr);
//
///* Creates FreeRTOS task to be used as a socket listener for CSP
 //*
 //*\param:	listen_port: the port number for the socket
 //*			*listener_ptr: pointer to a function that will be ran by the FreeRTOS task
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_create_listener(uint8_t listen_port, void (*listener_ptr)(void *arg_ptr));
//
///* Creates a socket to be used in the listener
 //*
 //*\param:	port: the port number for the socket
 //*\param:	socket_opt: socket option
 //*\return:	a pointer to the created socket
 //*/
//csp_socket_t * create_listen_socket(uint8_t port, uint32_t socket_opt);
//
///* transmits data over CSP with the reliable RDP protocol
 //*
 //*\param:	type: DATA/COMMAND/DATA_AND_COMMAND - Specifying what data is being sent
 //*			*dest: pointer to destination socket of type module_socket_t
			//*source: pointer to source socket of type module_socket_t
			//*data: pointer to the data being sent
			//size: size of data
			//command: the command to be sent with the data if type is set to COMMAND or DATA and COMMAND
			//priority: the priority of the transmission (0-3, 0 being highest priority)
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_rdp_transmit(packet_type_t type, module_socket_t *dest, module_socket_t *source, 
	//char *data, int size, command_t command, csp_prio_t priority);
//
///* transmits data over CSP with the unreliable UDP protocol
 //*
 //*\param:	type: DATA/COMMAND/DATA_AND_COMMAND - Specifying what data is being sent
 //*			*dest: pointer to destination socket of type module_socket_t
			//*source: pointer to source socket of type module_socket_t
			//*data: pointer to the data being sent
			//size: size of data
			//command: the command to be sent with the data if type is set to COMMAND or DATA and COMMAND
			//priority: the priority of the transmission (0-3, 0 being highest priority)
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_transmit(packet_type_t type, module_socket_t *dest, module_socket_t *source, 
	//char *data, int size, command_t command, csp_prio_t priority);
//
///* Method used to split an oversized packet into smaller packets that are sent individually.
 //* Uses the CMD_SPLIT_START command in the first packet, and CMD_SPLIT_STOP command in 
 //* the last packet, which can be used to regenerate the data on the receiving end. 
 //* The method is called automatically if the size of data
 //* in the csp_transmit call is above 60 bytes
 //*
 //*\param:	size: size of data
			//*i2c_address: address of receiver
			//*dest: destination port
			//*src: source port
			//*data: data to be sent
			//num_packets: number of packets to be split into
			//priority: the priority of the csp transmission
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_split_packet(int size, uint8_t *i2c_addr, uint8_t *dest, uint8_t *src,
	 //char *data, int num_packets, csp_prio_t priority);
//
///* Sending a csp packet containing data only
 //*
 //*\param:	*i2c_address: address of receiver
			//*dest: destination port
			//*src: source port
			//*data: data to be sent
			//size: size of data
			//priority: the priority of the csp transmission
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_send_data(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port,
	 //char *data, uint8_t size, csp_prio_t priority);
//
///* Sending a csp packet containing command only
 //*
 //*\param:	*i2c_address: address of receiver
			//*dest_port: destination port
			//*src_port: source port
			//command: the command
			//priority: the priority of the csp transmission
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_send_command(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port,
	 //command_t command, csp_prio_t priority);
//
///* Sending a packet containing both a command and data. command is placed in 
 //* the beginning of the packet
 //*
 //*\param:	*i2c_address: address of receiver
			//*dest_port: destination port
			//*src_port: source port
			//*data: data to be sent
			//size: size of data
			//command: command to be sent with the data
			//priority: the priority of the csp transmission
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_send_command_and_data(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, 
	//char *data, uint8_t size, command_t command, csp_prio_t priority);
//
///* Calls the csp sending function from the CSP library
 //*
 //*\param:	*i2c_address: address of receiver
			//*dest: destination port
			//*src: source port
			//csp_flags: option to set flags for encryption of data/etc
			//*packet: csp_packet_t struct containing the packet
			//priority: the priority of the csp transmission
 //*\return:	0 on success, negative on error
 //*/
//int8_t csp_send_packet(uint8_t *i2c_addr, uint8_t *dest_port, uint8_t *src_port, 
	//uint8_t csp_flags, csp_packet_t *packet, csp_prio_t priority);
//
//void * csp_buffer_get_wrapper(size_t size);
//#endif /* CSP_CONTROLLER_H_ */