/*
 * csp_example.h
 *
 * Created: 12-Nov-14 12:06:02 PM
 *  Author: Erlend
 */ 


#ifndef CSP_EXAMPLE_H_
#define CSP_EXAMPLE_H_

#include "portmacro.h"


/* 
 * Simple example setup
 */
void example_setup_of_listener(portCHAR * listen_port);

void example_setup_of_printout_listener(portCHAR * listen_port);

void example_setup_of_server(portCHAR * listen_port);

void example_serv_listen(void *ptr);

void example_test(void *ptr);

/* Simple example of how to send a NRP(reliable) packet-stream using CSP
 * Function is called from the CSP CLI directory
 *
 * @param str:				("message@address:port")
 *
 * @return:					void
 */
void example_send_nrp_message(portCHAR * str);

/* Simple example of how to send a Unreliable NRP packet using CSP
 * Function is called from the CSP CLI directory
 *
 * @param: str ("message@address:port")
 *
 * @return: void
 */
void example_send_unrp_message(portCHAR * str);


#endif /* CSP_EXAMPLE_H_ */