/*
 * data.h
 *
 * Created: 05.05.2015 19:25:31
 *  Author: mariuwes
 */ 

#include <stdint.h>

#ifndef DATA_H_
#define DATA_H_

// States
#define MODE_IDLE 0
#define MODE_DETUMBLING 1
#define MODE_TUMBLING 2
#define MODE_ESTIMATION 3
#define MODE_POINTING 4

typedef struct{
	int16_t year;
	int16_t mon;
	int16_t day;
	int16_t hr;
	int16_t min;
	double sec;
} Time;

typedef struct {
	int mode;
	Time time;
	int16_t gyroscope_data[12];
	int16_t magnetometer_data[12];
	int16_t sun_sensor_data[16];
	double predictor_data[12];
	float estimator_data[16];
	int16_t output_vector[3];
} Data;

typedef struct {
	int mode;
	char TLE[136];
	float R[9];
	float Q[25];	
} PersistentVariables;

#endif /* DATA_H_ */