/*
 * main.h
 *
 * Created: 05.05.2015 17:08:48
 *  Author: mariuwes
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#include <stdint.h>

// States
#define MODE_IDLE 0
#define MODE_DETUMBLING 1
#define MODE_TUMBLING 2
#define MODE_ESTIMATION 3
#define MODE_POINTING 4

// CSP to ADCS messages
#define SET_MODE 0
#define GET_MODE 1
#define GET_TIME 2
#define GET_DATA 3
#define UPDATE_PREDICTOR_TLE 4
#define UPDATE_SENSOR_TEMP 5
#define RECALIBRATE_SENSORS 6

// ADCS to CSP messages
#define SEND_MODE 0
#define SEND_TIME 1
#define SEND_DATA 2
#define GET_SENSOR_TEMP 3

#ifndef MAIN_H_
#define MAIN_H_

typedef struct{
	int16_t year;
	int16_t mon;
	int16_t day;
	int16_t hr;
	int16_t min;
	double sec;
} Time;

typedef struct {
	int mode;
	Time time;
	int16_t gyroscope_data[9];
	int16_t magnetometer_data[9];
	int16_t sun_sensor_data[16];
	int16_t sensor_data[6];
	float estimator_data[16];
	double predictor_data[12];
	int16_t output_vector[3];
} DataStruct;

typedef struct {
	int messageID;
	DataStruct data;
} ADCStoCSPstruct;

typedef struct {
	int messageID;
	int mode;
	
	char predictorTLE[139];
} CSPtoADCSstruct;

#endif /* MAIN_H_ */